#!/usr/bin/perl

use strict;
use Getopt::Std ;
use vars qw($opt_n $opt_i $opt_v $opt_h  );

#declaration des variables
my $version;
my $nom_liste;
my $domaine_i;
my $domaine_r;
my $i_domaine; #nom domaine interne passé en paramètre => pas de templatisation !
my $aliases="/etc/mail/sympa_aliases"; # fichier des alias pour sympa

#affichage et utilisation du programme
$version = 2.0;
my $copyright = "\n";
$copyright .= "    delete-list.pl v. $version.\n\n";
$copyright .= "    Utilitaire de suppression de liste Sympa.\n";
$copyright .= "    Copyright (c) 2003 Joel Cuissinat <joel.cuissinat\@ac-dijon.fr>.\n\n";
$copyright .= "    Copyright (c) 2002 Kévin Reverchon <kevin.reverchon\@ac-dijon.fr>.\n\n";
$copyright .= "    create-list.pl EST UN LOGICIEL LIBRE. SE RÉFÉRER AU CODE SOURCE\n";
$copyright .= "    POUR LA LICENCE D'UTILISATION ET DE COPIE.\n\n";

my $help = "syntaxe pour utiliser create-list.pl\n";
$help .= "./delete-list.pl -n le nom de la liste\n";
$help .= "./delete-list.pl -i le nom du domaine interne\n";
$help .= "./delete-list.pl -v: affiche le copyright\n";
$help .= "./delete-list.pl -h: affiche ce message\n";


#gestion des options
unless( getopts('i:n:vh') )
{
	#print STDERR $help;
   print $help;
    exit 0;
}

#affichage la version et le copyright si option -v

if( $opt_v )
{
   print STDERR $copyright;
    exit 0;
}

#affichage de l'aide si option -h

if($opt_h) 
{
    print STDERR $help;
    exit 0;
}


# nom de la liste
if($opt_n) 
{
    $nom_liste = $opt_n;
} else {
    print "Erreur : pas nom de liste (option n)";
    exit 0;
}

# domaine interne
if($opt_i) 
{
    $i_domaine = $opt_i;
} else {
    print "Erreur : pas de domaine interne (option i)";
    exit 0;
}

#initialisation des domaines
$domaine_r = "/var/lib/sympa/expl/".$i_domaine."/";
$domaine_i = "/var/lib/sympa/expl/";

##############################################################################################################
#                                                     Programme
#
#############################################################################################################

# suppression des alias de la liste :
my $rm_aliases="cat $aliases|grep -v ^".$nom_liste."- |grep -v ^".$nom_liste.": > $aliases" ;

if (-e "$domaine_i$nom_liste")
{
   `rm -rf $domaine_i$nom_liste`;
   `$rm_aliases`;
   print  "la liste $domaine_i$nom_liste a été supprimée";
} else {

    if (-e "$domaine_r$nom_liste")
    {
	`rm -rf $domaine_r$nom_liste`;
        `$rm_aliases`;
	print "la liste $domaine_r$nom_liste a été supprimée";
    }else {
       #print "Nom de liste introuvable, veuillez verifier que la liste $nom_liste existe bien merci!";
       print "Pas de liste de diffusion pour le groupe $nom_liste";

    }
}


##############################################################################################################
#                                                  Fin Programme
#
#############################################################################################################
