#!/bin/bash
# SCRIPT de sauvegarde différée

# fichier de log
F_LOG='/var/www/ead/tmp/at-bande.txt'

> $F_LOG

if [ "$1" == "0" ]; then
	# sauvegarde immédiate lançée avec at
	if [ "$2" == "-R" ] ; then
		# propagation de l'option 'sauvegarde restreinte' (-R)
		echo "/usr/share/ead/engine-sauv-bande.sh -R" | at now
	else
		at now -f "/usr/share/ead/engine-sauv-bande.sh"
	fi
else
	# suppression des autres sauvegardes bande différées
	sudo /usr/share/ead/purge-at.sh bande
	
	# sauvegarde différée habituelle
	if [ "$2" == "-R" ]
	then
		# propagation de l'option 'sauvegarde restreinte' (-R)
		echo -n "Sauvegarde restreinte programm&eacute;e le ">> $F_LOG
		date >> $F_LOG
		echo  "<BR> Pour dans $1 Heures " >> $F_LOG
		# on est obligé de mettre feinter le at pour qu'il prenne le paramètre !
		echo "/usr/share/ead/engine-sauv-bande.sh -R" | at now + "$1 hours"
	else
		echo -n "Sauvegarde complète programm&eacute;e le ">> $F_LOG
		date >> $F_LOG
		echo  "<BR> Pour dans $1 Heures " >> $F_LOG
		at now + "$1 hours" -f "/usr/share/ead/engine-sauv-bande.sh"
	fi
fi
