#!/usr/bin/env python
# -*- coding: UTF-8 -*-

#    Conception :
#    Eole (http://eole.orion.education.fr)

#    Copyright (C) 2002

#    Ce code a été développé par
#    Klaas TJEBBES

#    distribué sous la licence GPL-2

#    Version $Revision: 1.5 $

from xml.dom.minidom import parse
import sys


def extraitValeur(regle):
    #extrait la valeur de type type_val dans la regle maregle
    #les type_val sont ID, OS, Chemin, Intitule, Composant, Variable, ValeurSiCoche, ValeurSiDecoche
    #renvoi un dictionnaire
    #dictionnaire keys : id, os, chemin, intitule, composant, type_variable, variable, valeur, valeur_decoche
    ###########
    trouve = 0
    dico = {}
    node_id = regle.getElementsByTagName('ID')[0]
    node_os = regle.getElementsByTagName('OS')[0]
    node_chemin = regle.getElementsByTagName('Chemin')[0]
    node_intitule = regle.getElementsByTagName('Intitule')[0]
    node_composant = regle.getElementsByTagName('Composant')[0]
    node_variable = regle.getElementsByTagName('Variable')[0]
    node_valeur = regle.getElementsByTagName('ValeurSiCoche')[0]
    node_valeur_decoche = regle.getElementsByTagName('ValeurSiDecoche')[0]
    dico['id'] = str(node_id.childNodes[0].data)
    dico['os'] = str(node_os.childNodes[0].data)
    dico['chemin'] = str(node_chemin.childNodes[0].data)
    try:
        dico['intitule'] = str(node_intitule.childNodes[0].data)
    except:
        dico['intitule'] = node_intitule.childNodes[0].data
    dico['composant'] = str(node_composant.childNodes[0].data)
    dico['type_variable'] = str(node_variable.getAttribute('type'))
    dico['variable'] = str(node_variable.childNodes[0].data)
    try:
        dico['valeur'] = node_valeur.childNodes[0].data
    except:
        dico['valeur'] = ''
    try:
        dico['valeur_decoche'] = node_valeur_decoche.childNodes[0].data.encode('ISO-8859-1')
    except:
        dico['valeur_decoche'] = ''
    return dico

#défini le type de variable tel qu'il doit apparaître dans le fichier reg
def type_variable(mesvaleurs):
    if mesvaleurs['type_variable'] == 'DWORD':
        mesvaleurs['type_variable'] = 'dword:'
    else:
        mesvaleurs['type_variable'] = ''
    return mesvaleurs

#recherche une règle grâce à l'id fournie
def rechercher_regle(regles,id_rech):
    trouve = 0
    for regle in regles:
        i_d = regle.getElementsByTagName('ID')[0]
        id_a_rech = i_d.childNodes[0].data
        if id_a_rech == id_rech:
            trouve = 1
            regle_trouve = regle
    if trouve == 0:
	print "regle non trouvée"
	sys.exit(1)
    return regle_trouve

def main(mon_document,id_rech):
    mon_document = parse(mon_document)
    regles = mon_document.getElementsByTagName("Regle")
    regle = rechercher_regle(regles,id_rech)
    mon_resultat = extrait_valeur(regle)
    return mon_resultat

if __name__ == "__main__":
    #try:
        document,id_rech=sys.argv[1],sys.argv[2]
        test = main(document,id_rech)
        print test
    #except:
    #    print "erreur"



