#!/bin/bash
# Mise en place d'un répertoire élève
# utilisation :
# sh rep-eleve.sh login classe quota_disque

# paramètres
USER=$1
CLASSE=$2
QUOTA=$3

# chemins
ABC="/home/"${USER:0:1}
REP=$ABC"/"$USER

# gestion de l'organisation alphabétique
if [ ! -d $ABC ]
then
	mkdir -p $ABC
	setfacl -m u:mail:r-x,g:mail:r-x $ABC
fi	

# création des répertoires
mkdir -p ${REP}/perso/prive
mkdir -p ${REP}/profiles
mkdir -p ${REP}/MailDir
# ftp/groupes
mkdir -p ${REP}/.ftp
ln -nsf ${REP}/perso ${REP}/.ftp/perso
ln -nsf /home/workgroups/${CLASSE} ${REP}/.ftp/${CLASSE}

# mise en place des ACL
# élève
setfacl -PRm u:$USER:rwx,g::---,o::--- ${REP}
# mail
setfacl -x u:$USER ${REP}/MailDir
setfacl -m u:mail:r-x,g:mail:r-x ${REP}
setfacl -m u:mail:rwx,g:mail:rwx ${REP}/MailDir
# profs
setfacl -m g:professeurs:r-x ${REP}
setfacl -m g:professeurs:r-x ${REP}/perso
# ftp/groupes
setfacl -m u:$USER:r-x ${REP}/.ftp
# ACLs par défaut
getfacl --access --absolute-names  ${REP} | setfacl -d -M- ${REP}
getfacl --access --absolute-names  ${REP}/perso | setfacl -d -M- ${REP}/perso
getfacl --access --absolute-names  ${REP}/perso/prive | setfacl -d -M- ${REP}/perso/prive
getfacl --access --absolute-names  ${REP}/profiles | setfacl -d -M- ${REP}/profiles
getfacl --access --absolute-names  ${REP}/MailDir | setfacl -d -M- ${REP}/MailDir
# pour les quotas
chown -R $USER ${REP}/perso


# mise en place du quota utilisateur
/usr/share/ead/set_quota.py $USER $QUOTA

# mise en place du lien classe pour les professeurs
mkdir -p /home/classes/${CLASSE}
ln -nsf ${REP}/perso /home/classes/${CLASSE}/$USER

