#!/bin/bash
# Mise en place d'un répertoire professeur
# utilisation :
# sh rep-prof.sh login quota_disque

# arguments
USER=$1
QUOTA=$2

# chemins
ABC="/home/"${USER:0:1}
REP=$ABC"/"$USER

# gestion de l'organisation alphabétique
if [ ! -d $ABC ]
then
	mkdir -p $ABC
	setfacl -m u:mail:r-x,g:mail:r-x $ABC
fi	

# création des répertoires
# on prévoit la création d'une @ locale
mkdir -p ${REP}/perso
mkdir -p ${REP}/profiles
mkdir -p ${REP}/MailDir
# ftp/groupes
mkdir -p ${REP}/.ftp
ln -nsf ${REP}/perso ${REP}/.ftp/perso

# mise en place des ACL
# professeur
setfacl -PRm u:$USER:rwx,g::---,o:--- ${REP}
# non récursif pour mail
setfacl -m u:mail:r-x,g:mail:r-x ${REP}
setfacl -m u:mail:rwx,g:mail:rwx ${REP}/MailDir
# ftp/groupes
setfacl -m u:$USER:r-x ${REP}/.ftp
# ACLs par défaut
getfacl --access --absolute-names  ${REP} | setfacl -d -M- ${REP}
getfacl --access --absolute-names  ${REP}/perso | setfacl -d -M- ${REP}/perso
getfacl --access --absolute-names  ${REP}/MailDir | setfacl -d -M- ${REP}/MailDir
# pour les quotas
chown -R $USER ${REP}/perso

# mise en place du quota utilisateur
/usr/share/ead/set_quota.py $USER $QUOTA

