<?php

/**
 * 
 *
 * @author 	FTafel
 */
class TafelTreeBranch {
	
	
	/**
	 *------------------------------------------------------------------------------
	 *							Propriétés
	 *------------------------------------------------------------------------------
	 */
	
	/**
	 * @access 	protected
	 * @var 	string			$id						L'id de l'arbre
	 */
	var $id;
	var $txt;
	var $img;
	var $imgclose;
	var $imgopen;
	var $open;
	var $dropAccepted;
	var $draggable;
	var $check;
	var $style;	
	var $canhavechildren;
	var $openlink;
	var $onopenpopulate;
	var $branches;

	var $textAttributes = array(
		'img',
		'imgopen',
		'imgclose',
		'style',
		'openlink',
		'droplink'
	);
	var $numericAttributes = array(
		'dropAccepted',
		'draggable',
		'open',
		'canhavechildren',
		'check',
		'editable',
		'last'
	);
	var $functionAttributes = array(
		'onclick',
		'ondblclick',
		'onbeforeopen',
		'onopen',
		'onedit',
		'onmouseover',
		'onmouseout',
		'ondrop',
		'ondropajax',
		'onopenpopulate'
	);
	
	
	/**
	 *------------------------------------------------------------------------------
	 *							Constructeur
	 *------------------------------------------------------------------------------
	 */
	
	/**
	 * Constructeur
	 *
	 * @access	public
	 * @param	string				id						L'id de la branche
	 * @param	string				txt						Le texte de la branche
	 */
	function TafelTreeBranch ($id, $txt){
		$this->id = $id;
		$this->txt = $txt;
		if ($id == 'id1') echo $this->open;
		$this->branches = array();
	}
	
	
	
	/**
	 *------------------------------------------------------------------------------
	 *							Fonctions getters et setters
	 *------------------------------------------------------------------------------
	 */
	
	function getId() {
		return $this->id;
	}
	function getText() {
		return $this->txt;
	}
	
	function setImgs ($img, $imgopen = null, $imgclose = null) {
		$this->img = $img;
		$this->imgopen = $imgopen;
		$this->imgclose = $imgclose;
	}
	
	function setOnOpenPopulate ($func, $link) {
		$this->onopenpopulate = $func;
		$this->openlink = $link;
		$this->canhavechildren = 1;
	}
	
	function isOpen ($open) {
		$this->open = ($open) ? 1 : 0;
	}
	function acceptDrop ($bool) {
		$this->dropAccepted = ($bool) ? 1 : 0;
	}
	function isDraggable ($bool) {
		$this->draggable = ($bool) ? 1 : 0;
	}
	function isChecked ($bool) {
		$this->check = ($bool) ? 1 : 0;
	}
	
	function setStyle ($style) {
		$this->style = $style;
	}
	
	
	
	/**
	 *------------------------------------------------------------------------------
	 *							Fonctions publiques
	 *------------------------------------------------------------------------------
	 */
	
	function addBranch ($id, $txt) {
		$branch = new TafelTreeBranch ($id, $txt);
		$this->branches[] = $branch;
		return $branch;
	}
	
	function getJSON ($debug = false, $virgule = '', $rt = '', $tab = '', $tabModel = '') {
		$tabModel = ($debug) ? '&nbsp;&nbsp;&nbsp;&nbsp;' : '';
		$rt = ($debug) ? '<br />' : '';
		$tab .= $tabModel;
		$str = $virgule.$rt.$tab.'{'.$rt;
		// Définition de toutes les propriétés
		$str .= $tab."'id' : '".$this->getId()."'";
		if ($this->getText()) $str .= ",".$rt.$tab."'txt' : '".$this->getText()."'";
		foreach ($this->textAttributes as $attr) {
			if (isset($this->$attr) && $this->$attr) $str .= ",".$rt.$tab."'".$attr."' : '".$this->$attr."'";
		}
		foreach ($this->numericAttributes as $attr) {
			if (isset($this->$attr) && $this->$attr) $str .= ",".$rt.$tab."'".$attr."' : ".$this->$attr;
		}
		foreach ($this->functionAttributes as $attr) {
			if (isset($this->$attr) && $this->$attr) $str .= ",".$rt.$tab."'".$attr."' : ".$this->$attr;
		}
		// Définition des enfants
		if (count($this->branches) > 0) {
			$virgule = '';
			$str .= ','.$rt.$tab."'items' : [";
			foreach ($this->branches as $branch) {
				$str .= $branch->getJSON($debug, $virgule, $rt, $tab, $tabModel);
				$virgule = ',';
			}
			$str .= $rt.$tab.']';
		}
		$str .= $rt.$tab.'}';
		return $str;
	}
	
	
}

?>
