<?php

/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */


if(get_admin_level($PHP_AUTH_USER) == 1)
{
	exit ("<H1>Vous n'avez pas la permission de créer des professeurs !</H1>");
}


// ajout d'un professeur
function add_user($domain_name,$user,$name,$givenName,$password,$Meflcf,$Divcod,$mail,$quota,$admin,$modele,$profilepath,$local,$code_civilite)
{
   global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass_admin, $domain_list, $branch_admin, $clss, $PHP_AUTH_USER, $perl_path;
   //ajout d'une globale
   //ce fichier a été modifié pour la verification des doublons entre amin et users
   global $branch_etab, $samba_server;

   $ds=ldap_connect($ldap_server,$ldap_port);
   if (!$ds) {
      $buffer = "Connexion au serveur ldap impossible\n";
      return $buffer;
   }
   //On bind 
   $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
   if (!$r) 	{
      $buffer = "Accès ldap refusé (problème de mot de passe ?)\n";
      return $buffer;
   }
   
   //On teste l'existence du user dans l'etablissement
   $filter = "(| (uid=$user))";
   $justthese = array("uid");
   $sr = ldap_search($ds, $branch_etab, $filter, $justthese);
   $info = ldap_get_entries($ds, $sr);
   $verify = $info["count"];
   ldap_close($ds); // autant le mettre dès ici (joel)
  
   if ($verify > 0) {	    
      $buffer = "La personne existe deja\n";
      return $buffer;	    
   }

   require_once "group-lib.inc";
   if (in_array($user,list_group('',''))) {
      $buffer = "Impossible d'ajouter le compte <b>$user</b>.<br>
      Un groupe possède déjà cet identifiant.";
      return $buffer;
   }

   // encore une bidouille pour distinguer profs et admin de classe !
   if ($Meflcf == '0') {
      // simple prof
      $droits='0';
      $Divcod='autre';
      if ($admin) {
         $groupes="-G DomainAdmins,PrintOperators";
      }
   } else {
      // prof principal de Divcod (profs : plus dans les classes)
      $droits='2';
      $groupes="-G profs-$Divcod";
      if ($admin) {
         $groupes.=",DomainAdmins,PrintOperators";
      }
   }

   if ($local == 'yes') {
      $mail = "local"; // mot clé ?
   }
		  
   $script= "sudo /usr/share/eole/backend/creation-prof.py";
   $para  = "-u $user ".
            "-c $Divcod ".
	    "-m \"".escapeshellarg($password)."\" ".
	    "-p \"".replace_carac($givenName)."\" ".
	    "-f \"".replace_carac($name)."\" ".
	    "-x $code_civilite ".
	    "-M $mail ".
	    "-z $droits ".
	    "$groupes ".
	    "-q ".(integer)$quota." ".
	    " -P \"$profilepath\"";

   // execution avec récup de la sortie sys.exit()
   $handle = popen("$script $para 2>&1",'r');
   while (!feof ($handle)) $buffer.= fgets($handle, 4096)."<br>";
   pclose($handle);
	  
   // ack pour ajout du modele
   if ($modele)`/usr/share/eole/backend/attribue-modele.py -u $user -m $modele`;
   
   return $buffer ;
}



function print_add_user($domain)
{
  global $domain_list, $dico;
  $taille=30;

  $buffer = "<form method=\"post\" action=\"resultat-add-admin-ldap.php\">";
  $buffer .= "<table cellpadding=2>";

  // champs à remplir
  $buffer .= "<tr><td>Login<br><i>(\"prenom.nom\" recommandé)</i></td><td>
  		<input type=\"text\" name=\"user\" size=$taille maxlength=\"20\"></td></tr>";
  $buffer .= "<tr><td>Nom </td><td>
  		<input type=\"text\" name=\"name\" size=$taille></td></tr>";
  $buffer .= "<tr><td>Prénom </td><td>
  		<input type=\"text\" name=\"givenName\" size=$taille></td></tr>";
  $buffer .= "<tr><td>Mot de passe </td><td>
	      <input type=\"password\" name=\"password\" size=$taille></td></tr>";
  $buffer .= "<tr><td>Civilité</td><td colspan=2><select name=\"code_civilite\">";
  $buffer .= "<option value=\"1\">M.</option>";
  $buffer .= "<option value=\"2\">Mme</option>";
  $buffer .= "<option value=\"3\">Mlle</option></select></td></tr>";
  // mail
  // radio "local" avec "no" en précoché
  $buffer.="<tr><td>Adresse e-mail<br><i>(personalisée<br><b>ou</b> locale)</i></td><td>
	           <input type=\"radio\" name=\"local\" value=\"no\" CHECKED>		   
	           &nbsp;Adresse personalisée :<br>&nbsp;&nbsp;
		   <input type=\"text\" name=\"mail\" size=\"28\" value=\"\">		   
		   <br>
		   <input type=\"radio\" name=\"local\" value=\"yes\">
		   &nbsp;Adresse locale :<br>&nbsp;&nbsp; <font size=-1>&lt;login&gt;@".$dico['domaine_messagerie_etab']."
		   </font></td><td>";
  $buffer .= "<tr><td>Quota disque <br>(0 pour inactif)</td><td>
		<input type=\"text\" name=\"quota\" value=\"0\" size=$taille></td></tr>";
#  $buffer.="<tr><td>Modèle Windows</td>
#          <td colspan=\"2\">";
#  $buffer.= liste_modeles("modele"); 
  $buffer.="</td></tr>";
  $buffer.='
          <tr><td width="40%">Profil utilisateur</td>
          <td width="60%"><select name="profilepath">
          <option value="1">local</option>
          <option value="2">obligatoire - profil</option>
          <option value="3">obligatoire - profil2</option>
          </select>';
  
  // choix de la CLASSE
  $buffer .= "<tr><td>Professeur principal &nbsp</td>";
  $buffer .= "<td><select name=Meflcf>";
  $buffer .= "<option value=\"0\" selected>non</option>";
  if ($liste_groupe=list_group("","N")){
     foreach ($liste_groupe as $groupe) {
        $buffer .= "<option value=\"$groupe\">d'une classe de $groupe</option>";
     }
  }
  $buffer .= "</select></td></tr>";

  // groupes spéciaux
  $buffer .= "<tr><td>Membre du groupe<br>DomainAdmins</td><td>
  		<input type=checkbox name=admin></td></tr>";
  
  $buffer .= "</table><br>";
  $buffer .= "<center><input type=\"submit\" value=\"Créer l'utilisateur\"></form>";
  $buffer .= "<br><br><center><a href=\"aide-add-user.php\">Aide</a></center>";
  return $buffer ;
}


function replace_carac($buffer)
{
  $buffer=strtr($buffer, "ÀÁÂÃÄÅàáâãäåÒÓÔÕÖØòóôõöøÈÉÊËèéêëÇçÌÍÎÏìíîïÙÚÛÜùúûüÿÑñ", "aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn");
  return $buffer;
}

?>
