<?php
/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */

//variables globales
global $PHP_AUTH_USER, $num_rne ;

//ajoute un eleve dans l'annuaire
function add_user($domain_name, $user, $name, $givenName, $password, $code_civilite, $Meflcf, $Divcod, $employeeNumber, $dateNaissance, $quota, $modele, $profilepath)
{
  //globales utilisées par la fonction
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass_eleve, $domain_list, $branch_eleve, $clss, $PHP_AUTH_USER, $num_rne, $perl_path;
  global $branch_etab, $samba_server;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";

    } else {

      //On bind 
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";

	} else {

	  //On teste son existence: il faut remonter d'un branche pour le test de l'existence car on peut avoir des doublons entre mail eleve et prof. enlever branche eleve et remonter o nivo etab.
	  $filter = "(| (uid=$user))";
	  $justthese = array( "uid");
	  $sr = ldap_search($ds, $branch_etab, $filter, $justthese);
	  $info = ldap_get_entries($ds, $sr);
	  $verify =  $info["count"];
	 
          require_once "group-lib.inc";
	  if ($verify > 0) {
		  
	      $buffer = "La personne existe deja<br><br>";
	      $buffer .='<center><input type=button value="Précédent" onclick="history.back();"> ';

	  } elseif (in_array($user,list_group('',''))) {

	       $buffer = "Impossible d'ajouter le compte <b>$user</b>.<br>
	       Un groupe possède déjà cet identifiant.";
	      
	  } else {
	  // tout le code ci-dessous

	  if(get_admin_level($PHP_AUTH_USER) == 1){
   	     // cas prof ppal : on vérifie les droits
             if (! in_array($Divcod, get_admin_class($PHP_AUTH_USER))){
                return "Pas de droits d'administration sur $Divcod !";
	     }
          }
		
	  // le niveau associé à la classe est déduit
	  require_once('group-lib.inc');
	  if (!$Meflcf=niveau($Divcod)) {
	     return("Erreur classe $Divcod");
	  }

          $script= "sudo /usr/share/eole/backend/creation-eleve.py";
	  $para  = "-u $user ".
		   "-c $Divcod ".
		   "-n $Meflcf ".
		   "-m \"".escapeshellarg($password)."\" ".
		   "-p \"".replace_carac($givenName)."\" ".
		   "-f \"".replace_carac($name)."\" ".
		   "-x $code_civilite ".
		   "-d ".(integer)$dateNaissance ." ".
		   "-o ".(integer)$employeeNumber." ".
		   "-D $domain_name ".
		   " -P \"$profilepath\" ".
		   "-q ".(integer)$quota." ";

	  // execution avec récup de la sortie sys.exit()
	  $handle = popen("$script $para 2>&1",'r');
	  while (!feof ($handle)) $buffer.= fgets($handle, 4096)."<br>";
          pclose($handle);

	  // ack pour ajout du modele
	  if ($modele)`/usr/share/eole/backend/attribue-modele.py -u $user -m $modele`;

	   //on mail ke si il n'y a pas eu de pbs dans la creation de l'utilisateur
	   //if (!mail("$user@$domain_name", "Bienvenue", "Votre compte de messagerie est actif", "From: Administrateur <$email_admin>")) {
	   //   $buffer.="<br>Echec d'envoi du mail à $user@$domain_name";
	   //}
	   }
        }
     }
     return $buffer ;
}

//affiche le formulaire d'ajout d'un user
function print_add_user($domain)
{
  global $domain_list, $PHP_AUTH_USER;

  
  if(get_admin_level($PHP_AUTH_USER) == 2)
    {
      $buffer = "Vous êtes connecté en tant que administrateur général:<br><br>";
    }

  $buffer = "<table><form method=\"post\" action=\"resultat-add-user-ldap.php\">";
  $buffer .= "<td>Donner le nom de login </td>";
  $buffer .= "<td><input type=\"text\" name=\"user\" maxlength=\"20\"></td>
              <td>@</td><td><select name=\"domain\">";
  $buffer .= list_domain_add($domain); 
  $buffer .= "</select></td><tr>";
  $buffer .= "<td>Donner le nom de l'utilisateur</td><td colspan=\"2\"><input type=\"text\" name=\"name\"></td><tr>";
  $buffer .= "<td>Donner le prenom de l'utilisateur</td><td colspan=\"2\"><input type=\"text\" name=\"givenName\"></td></tr>";
  $buffer .= "<td>Donner le mot de passe de l'utilisateur</td><td colspan=\"2\"><input type=\"password\" name=\"password\"></td><tr>";

//print("Adresse alternative <input type=\"text\" name=\"mailAlternate\"><br>");
// print("Texte libre <input type=\"text\" name=\"textelibre\"><br>");
// print("Adresse postale <input type=\"text\" name=\"postalAddress\"><br>");
 $buffer .=  "<td>Date de naissance</td><td colspan=2><input type=\"text\" name=\"dateNaissance\"></td>";
 $buffer .= "<td>(format : jj/mm/aaaa)</td><tr>";
 $buffer .= "<td>Civilité</td><td colspan=2><select name=\"code_civilite\">";
 $buffer .= "<option value=\"1\">M.</option>";
 $buffer .= "<option value=\"2\">Mme</option>";
 $buffer .= "<option value=\"3\">Mlle</option>
 </select></td><tr>";
 $buffer .= "<td>Numéro de l'élève<br>(ELENOET dans GEP)                 
 </td><td colspan=\"2\"><input type=\"text\" name=\"employeeNumber\"></td><tr>";
 $buffer .= "<td>Quota disque <br>(0 pour inactif)</td><td><input type=\"text\" name=\"quota\" value=\"0\"></td></tr>";
# $buffer.="<tr><td>Modèle Windows</td>
#          <td colspan=\"2\">";
# $buffer.= liste_modeles("modele"); 
# $buffer.="</td></tr>";
 $buffer.='
          <tr><td width="40%">Profil utilisateur</td>
	  <td width="60%"><select name="profilepath">
	  <option value="1">local</option>
	  <option value="2">obligatoire - profil</option>
	  <option value="3">obligatoire - profil2</option>
	  </select></td></tr>';

 // prof => ses classes, admin => toutes les classes
 if(get_admin_level($PHP_AUTH_USER) == 0) $liste_groupe=list_group("","C");
 else $liste_groupe=get_admin_class($PHP_AUTH_USER);

 if ($liste_groupe){
    $buffer .= "<tr><td>Classe</td>";
    $buffer .= "<td colspan=\"2\"><select name=Divcod>";
    foreach ($liste_groupe as $groupe) {
       $buffer .= "<option value=\"$groupe\">$groupe</option>";
    }
    $buffer .= "</select></td><tr>"; $buffer .= "</td></table>";
    $buffer .= "<center><input type=\"submit\" value=\"Créer l'utilisateur\"></form>";
    $buffer .= "<br><br><center><a href=\"aide-add-user.php\">Aide</a></center>";
 }else{
    // si pas de classes => pas de SUBMIT !
    $buffer = "ERREUR : Aucune classe n'a été trouvée !";
 }
 return $buffer ;
}

//fonction qui supprime les accents.
function replace_carac($buffer)
{
  $buffer=strtr($buffer, "ÀÁÂÃÄÅàáâãäåÒÓÔÕÖØòóôõöøÈÉÊËèéêëÇçÌÍÎÏìíîïÙÚÛÜùúûüÿÑñ", "aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn");
  return $buffer;
}

?>
