<?php
/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */

global $PHP_AUTH_USER;

//affiche le domaine mail actuel d'une personne 
function display_status_domain_mail ($uid)
{
    global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base,$ldap_objclass_eleve,$branch_eleve, $domaine_restreint, $domaine_internet ;

    //connection 
    $ds=ldap_connect($ldap_server,$ldap_port);
    if (!$ds)
      {
	$buffer = "Can't connect to Ldap server ($ds)\n";
	// exit();
      } else {
    
    //bind
	$r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
	if (!$r)
	  {
	    $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	    // exit();
	  } else {
	    $attribute = "mail";
	    //$uid = $uid ;
	    //lire
	    $r = @ldap_read($ds,"uid=$uid,$branch_eleve","objectclass=$ldap_objclass_eleve");

	    if (@ldap_count_entries($ds,$r)<=0)
	      {
		ldap_close($ds);
		return;
	      }

	   
	    $e = ldap_first_entry($ds,$r);

	    $values = ldap_get_values($ds,$e,$attribute);
	    $buffer = "L'adresse mail actuel de $uid est: $values[0]" ; 
	    $domain_mail =  split ("@",  $values[0]) ;
	    $buffer = "<Form method =\"post\" action =\"resultat-domain-mail.php?uid=$uid\">";
	   
	    if ( $domain_mail[1] == $domaine_restreint )
	      {
		$buffer .= "domaine restreint: <input name =\"radio_domain\" type =\"radio\" value =\"restreint\" checked>&nbsp;&nbsp;&nbsp;&nbsp;";
		$buffer .= "domaine internet<input name =\"radio_domain\" type =\"radio\" value =\"internet\">";
	      } else {
		$buffer .= "domaine restreint: <input name =\"radio_domain\" type =\"radio\" value =\"restreint\">&nbsp;&nbsp;&nbsp;&nbsp;";
		$buffer .= "domaine internet<input name =\"radio_domain\" type =\"radio\" value =\"internet\" checked>";
		$buffer .= "<br>";
	      }
	      $buffer .=  "<input type=\"submit\" Value =\"Modifier\"></Form>";


	  }
      }

    ldap_close($ds);
    return $buffer ;
}


//modifie le domaine mail d'une personne
function modify_user_domain_mail($uid)
{
 
    global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base,$ldap_objclass_eleve,$branch_eleve, $domaine_restreint, $domaine_internet, $radio_domain ;

    //connection 
    $ds=ldap_connect($ldap_server,$ldap_port);
    if (!$ds)
      {
	$buffer = "Can't connect to Ldap server ($ds)\n";
	// exit();
      } else {
    
    //bind
	$r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
	if (!$r)
	  {
	    $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	    // exit();
	  } else {
	    $attribute = "mail";
	    //$uid = $text_uid ;
	    //$value= $text_new_pwd ;
	    	    
	    //lire
	    $r = @ldap_read($ds,"uid=$uid,$branch_eleve","objectclass=$ldap_objclass_eleve");

	    if (@ldap_count_entries($ds,$r)<=0)
	      {
		ldap_close($ds);
		return;
	      }

	   
	    $e = ldap_first_entry($ds,$r);

	    $values = ldap_get_values($ds,$e,$attribute);
	    	    	    
	    $mail =  split ("@", $values[0]);

	    if ( $radio_domain == "restreint" )
	      {
		$value = $mail[0]."@".$domaine_restreint ;
	      } else {
		if ( $radio_domain == "internet" )
		  {
		    $value = $mail[0]."@".$domaine_internet ;
		  }
	      }
	    
	   
	    $entry[$attribute]= $value;
	    
	    $r = ldap_modify($ds,"uid=$uid,$branch_eleve",$entry);
	    if (!$r)
	      {
		$buffer ="Un problèmes est survenu, l'utilisateur n'a pas été modifié<br>";
	
	      } else {
		$buffer = "L'utilisateur '$uid' a été modifié<br>";
	      }   
	  }
      }
  ldap_close($ds);
  return $buffer ;
}

?>