<?
/*
=======================================================================

  moteur de génération des fichiers de données et accès aux fichiers
  $Id: data-access-lib.inc,v 1.1.1.1 2004/01/05 10:17:33 eole Exp $
=======================================================================

-
 Ce module permet l'execution lancer un script bash externe
 C'est la partie engine

 Il permet aussi de se renseigner sur l'état des données à gérer
 c'est la partie accès aux données : data_access

-

 Fonctions : 
 
 Script
 ScriptSimple
 ZcatSquidGuard
 AliveMatch
 AliveService
 setAliveService

-

 Remarques :

 Il vaudrait mieux, pour des raisons d'api, faire que Script renvoie quelque chose
 du genre true ou false...
 Dans ScriptSimple, il faudrait faire un rapport de log comme dans Script

=======================================================================
*/


/*
=======================================================================

                          moteur (engine) 
		  génération des fichiers de données

=======================================================================
*/



  /*
    Script
    -
    exécute le script et renvoie le résultat dans le fichier résultat correspondant
    -
    Paramètres : 
    $script_name // nom du script à invoquer
    $result_file // fichier dans lequel le résultat sera placé
    -
    valeur retournée : 
    rien
    -
    Globales :
    $path_log, $error_engine_log, $engine_path, $data_access_path;
    PrintDate(), String2File(),l()
    - 
  */
function Script($script_name,$result_file)
{

  global $path_log, $error_engine_log, $engine_path, $data_access_path;

  $escape = escapeshellarg($script_name);
  $script = $engine_path.$escape ;
  $buffer = `$script` ;
  
  if ($buffer == '') 
    {

      return 0 ;

      $msg = PrintDate() ;
      $msg .= "le script $script_name a échoué " ;
      $log_file = $path_log.$error_engine_log ;
      l($msg,$log_file) ;

    } else  {
      
      $result_file = $data_access_path.$result_file ;

      // purge des zarbis

      String2File($buffer,$result_file) ;  


    }

}


  /*
    ScriptSimple 
    -
    Simple exécution d'un script sans aucune sortie
    -
    Paramètres : 
    $script_name // nom du script à éxecuter
    -
    valeur retournée : 
    rien
    -
    Références Globales :
    $path_log, $error_engine_log, $engine_path, $data_access_path
    PrintDate(),l($msg,$log_file)
    - 
  */

function ScriptSimple($script_name)
{


  global $path_log, $error_engine_log, $engine_path, $data_access_path;

  // filtrage des mauvaises intentions
  $escape = escapeshellarg($script_name);
  $script = $engine_path.$escape ;
  // bienvenue aux pirates
  $buffer = `$script` ;
  
  if ($buffer == '') 
    {

      return 0 ;

      $msg = PrintDate() ;
      $msg .= "le script $script_name a échoué " ;
      $log_file = $path_log.$error_engine_log ;
      l($msg,$log_file) ;

    } else  {

      // c'est que ça a marché. Et vogue la galère.
      return 1 ;

    }

}

  /*
    ScriptSimple 
    -
    Simple exécution d'un script sans aucune sortie
    -
    Paramètres : 
    $script_name // nom du script à éxecuter
    -
    valeur retournée : 
    rien
    -
    Références Globales :
    $path_log, $error_engine_log, $engine_path, $data_access_path
    PrintDate(),l($msg,$log_file)
    - 
  */

function ScriptParametre( $str_script_name , $str_parametre )
{


  global $engine_path ;

  // filtrage des mauvaises intentions
  $escape_script = escapeshellarg($str_script_name);
  $escape_parametre = escapeshellarg($str_parametre);

  $script = $engine_path.$escape_script." ".$escape_parametre ;
  // bienvenue aux pirates
  $buffer = `$script` ;
  
  return TRUE ;

}


/*
ZcatSquidGuard
-
test pour le result-sem-dernière de SquidGuard  
est exécuté dans index.php pour savoir s'il est nécessaire
de décompresser le fichier semaine dernière 
-
Paramètres :
aucun
-
Résultat :
aucun
-
Globales :
$engine_squid_sem_dern , $data_access_path , $data_access_squid_sem_dern ;
Script()
 */
function ZcatSquidGuard()  
{
  
  

  global $engine_squid_sem_dern , $data_access_path , $data_access_squid_sem_dern ;

  $fichier = $data_access_path.$data_access_squid_sem_dern ;

  $time_stamp = filectime($fichier) ;

  $time = time() ;
  $dte_debut_jour = mktime(0,0,0,date("m",$time),date("d",$time),date("Y",$time))  ;
  
  if ( $dte_debut_jour >= $time_stamp )  
    {
      
      Script($engine_squid_sem_dern,$data_access_squid_sem_dern) ;

    } else  
      {
	// ne fait rien, inutile de décompresser

      }

}


/*
=======================================================================

                            data-access
			 accès aux données

=======================================================================
*/


  /*
    AliveMatch
    -
    repérage d'un motif de type service et test de son activité
    -
    Paramètres : 
    $pattern     // service à rechercher
    $string     // ligne du fichier de log
    -
    valeur retournée : 
    rien
    -
    Globales :
    $path_log, $error_engine_log, $engine_path, $data_access_path;
    PrintDate() String2File()
    - 
  */
function AliveMatch( $pattern ,$string)
{
  if (eregi($pattern,$string))
    {

      if (eregi("alive",$string)) 
	{
	  // si le service est alive
	  return 1 ;

	} else {

	  return 0 ;

	}
    }
  return 8;
}

  /*

    function AliveService()
    
    -
    cette fonction renvoie un vecteur des services qui fonctionnent
    mais ne modifie pas le vecteur active_service
    
    -
    Paramètres : 
    pas de paramètres
    -
    valeur retournée : 
    $alive_service ; tableau des services actifs
    -
    Globales :
    $active_service, $data_access, $data_access_log ;
    AliveMatch()
    - 
  */

function AliveService()
{
  global $active_service, $data_access_path, $data_access_log ;
  $log_file = $data_access_path.$data_access_log ;

  $file_lines = file($log_file) ;
  $service = array_keys($active_service) ;

  foreach ($service as $keys )
  {

      foreach ($file_lines as $keys_data) 
      {
         
        $alive=AliveMatch($keys,$keys_data) ;
        if ($alive==1)  {
	  // si le service est alive, met true
	  $alive_service[$keys] = 1 ;
	  continue ;
	}
	elseif ($alive==0) {
	  $alive_service[$keys] = 0 ;
	  continue ;
	}
      }
  }
  return $alive_service ;
}

/*
setAliveService
-
update le vecteur des services actifs à la suite du test des services actifs
-
Paramètres : 
aucun
-
Résultat : 
aucun
-
Globales :
$active_service
AliveService()
-
 */
function setAliveService()  {
  
  global $active_service ;

  $alive = AliveService() ;
  $active_service = array_merge ($active_service,$alive);

}

?>
