<?php
/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */

function view_user ($uid, $is_admin)
{

   global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,
    $branch_eleve,$ldap_objclass_eleve, $branch_admin,$ldap_objclass_admin,$autres_groupes,
    $PHP_AUTH_USER;

   // connexion à ldap
   if (! $ds=ldap_connect($ldap_server,$ldap_port)) {
      return ("Connexion à LDAP impossible");
   }
  
   // bind LDAP
   if (! $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw)) {
      return ("Erreur de liaison LDAP, vérifiez le mot de passe");
   }
  
   if ($is_admin == 0) {
   
   //###########//
   // cas élève //
   //###########//
      
      // lecture (branche élève)
      $r = @ldap_read($ds,"uid=$uid,$branch_eleve","objectclass=$ldap_objclass_eleve");
      // test attributs
      if (@ldap_count_entries($ds,$r)<=0) {
         return ("L'élève $uid n'a pas été trouvé");
      }
      // normalement une seule entrée 
      $entry = ldap_first_entry($ds, $r);
      // récup des infos
      $attrs = ldap_get_attributes($ds, $entry);
      
      // droits pour administrateur et prof admin de la classe *trouvée*
      if(get_admin_level($PHP_AUTH_USER) != 0){
         if (! in_array($attrs["Divcod"][0], get_admin_class($PHP_AUTH_USER))){
            return("Pas de droits sur la classe ".$attrs["Divcod"][0]);
         }
      }
      
      // présentation du résultat
      $buffer.= "<table>";      
      // affichage des informations élève
      $buffer.= champ_non_modifiable("Identifiant",$attrs["uid"][0]);
      $buffer.= champ_modifiable("Identité",$attrs["displayName"][0],"displayName",$uid,$is_admin);      
      //$buffer.= champ_modifiable("Nom",$attrs["sn"][0],"sn",$uid,$is_admin);
      //$buffer.= champ_modifiable("Prénom",$attrs["givenName"][0],"givenName",$uid,$is_admin);      
      $buffer.= champ_civilite("Civilité",$attrs["codecivilite"][0],"codecivilite",$uid,$is_admin);
      $buffer.= champ_modifiable("Adresse",$attrs["postalAddress"][0],"postalAddress",$uid,$is_admin);
      $buffer.= champ_non_modifiable("Adresse e-mail",$attrs["mail"][0]);

      foreach (array(0=>'Mail parent n°1', 1=>'Mail parent n°2') as $nb=>$label) {
          if ($attrs["mailparent"][$nb]) {
	      // mailparent déjà défini -> modification
	      $buffer.= champ_modifiable($label,$attrs["mailparent"][$nb],"mailparent$nb",$uid,$is_admin);
	  }else{
	      // mailparent non existant -> ajout
	      $buffer.="<form method=post><tr><td>$label<td><input type=\"text\" name=\"value\" size=\"33\"></td><td>
			<input type=hidden name=uid value=\"$uid\">
			<input type=hidden name=is_admin value=\"$is_admin\">
			<input type=hidden name=action value=\"mailparent\">
			<input type=submit name=sub value=\"Ajouter\"></td></tr></form>";
	      // si le "Mail parent n°1" n'est pas défini, on ne propose pas l'autre 
	      break;
          }
      }
      $buffer.= champ_modifiable("Numéro de l'élève<br>(ELENOET dans GEP)",$attrs["employeeNumber"][0],"employeeNumber",$uid,$is_admin);
      $buffer.= champ_modifiable("Date de naissance",$attrs["dateNaissance"][0],"dateNaissance",$uid,$is_admin);
      // cas particulier : le quota !
      $r=exec("/usr/share/ead/get_quota.py $uid");
      $buffer.= champ_modifiable("Quota disque <br>(0 pour inactif)",$r,"quota",$uid,$is_admin);

      // encore un cas particulier : le profil, obligatoire / local (eleve)
      if (get_admin_level($PHP_AUTH_USER) == 0) {
      if ($attrs["sambaProfilePath"][0]) {
         if (strpos($attrs["sambaProfilePath"][0],'2')) $sel_obli2="selected";
	  else $sel_obli="selected";
      }
      else {
         $sel_local="selected";
      }
      $buffer.='
      <form method=post><tr><td width="40%">Profil utilisateur</td>
      <td width="60%"><select name="profilepath">
      <option value="0" '.$sel_local.'>local</option>
      <option value="1" '.$sel_obli.'>obligatoire - profil</option>
      <option value="2" '.$sel_obli2.'>obligatoire - profil2</option>
      </select>
      </td><td>
      <input type=hidden name=value value=profil>
      <input type=hidden name=uid value='.$uid.'>
      <input type="submit" name="action" value="Appliquer">
      </td></tr></form>';
      } //fin profil
      
#      // cas particulier : le modèle Windows !
#      $buffer.= "<form method=post><tr><td>Modèle Windows</td><td>
#                <table width=\"100%\"><tr><td>[<b>";
#      $buffer.=`/usr/share/eole/backend/attribue-modele.py -u $uid`;
#      $buffer.="</b>]</td><td><center>";
#      $buffer.=liste_modeles("value","SUPPR");
#      $buffer.="</td></tr></table>";
#      $buffer.= "</td><td><input type=hidden name=uid value=\"$uid\">
#		 <input type=submit name=action value=\"Appliquer\">
#		 </td></tr></form>";
      
      // autres infos
      $buffer.= champ_non_modifiable("Niveau",$attrs["Meflcf"][0]);
      $buffer.= champ_non_modifiable("Classe",$attrs["Divcod"][0]);
      $buffer.= "<form action=change-classe.php method=post><tr><td>Changement de classe</td><td>
      		<input type=hidden name=uid value=\"$uid\">
		<input type=submit name=action value=\"Appliquer\">
		</td></tr></form>";
      // fin des informations
      
      // gestion des groupes
      $buffer.= choix_groupes("Groupe","Groupe",$uid,$is_admin);
      // fin gestion
      
      $buffer .= "</table>";
      ldap_close($ds);
   }
   else {
   
   //################//
   // cas professeur //
   //################//
      // lecture (branche prof)
      $r = @ldap_read($ds,"uid=$uid,$branch_admin","objectclass=$ldap_objclass_admin");
      // test attributs
      if (@ldap_count_entries($ds,$r)<=0) {
         return ("Le professeur $uid n'a pas été trouvé");
      }
      // normalement une seule entrée 
      $entry = ldap_first_entry($ds, $r);
      // récup des infos
      $attrs = ldap_get_attributes($ds, $entry);
      // titre
      $buffer = "<table>";
      // affichage des informations prof
      $buffer.= champ_non_modifiable("Identifiant",$attrs["uid"][0]);
      $buffer.= champ_modifiable("Identité",$attrs["displayName"][0],"displayName",$uid,$is_admin);
      
      // upgrade : ajout de l'attribut "codecivilite" si inexistant :      
      if (!array_key_exists("codecivilite", $attrs)) {
         add_user_attribute($uid,"codecivilite","0",0,$is_admin);
	 $attrs["codecivilite"][0] = "0";
      }
      $buffer.= champ_civilite("Civilité",$attrs["codecivilite"][0],"codecivilite",$uid,$is_admin);
      
      //$buffer.= champ_modifiable("Nom",$attrs["sn"][0],"sn",$uid,$is_admin);
      //$buffer.= champ_modifiable("Prénom",$attrs["givenName"][0],"givenName",$uid,$is_admin);
      // 17/10/2005 : choix adresse mail locale ou personnalisée 
      include "champmail.php";
      
      // cas particulier : le quota !
      $r=exec("/usr/share/ead/get_quota.py $uid");
      $buffer.= champ_modifiable("Quota disque <br>(0 pour inactif)",$r,"quota",$uid,$is_admin);
      
      // encore un cas particulier : le profil, obligatoire / local (prof)
      $sel_local=$sel_obli=$sel_obli2='';
      if (array_key_exists("sambaProfilePath",$attrs)) {
         if (strpos($attrs["sambaProfilePath"][0],'2')) $sel_obli2="selected";
	 else $sel_obli="selected";
      }
      else $sel_local="selected";
      $buffer.='
      <form method=post><tr><td width="40%">Profil utilisateur</td>
      <td width="60%"><select name="profilepath">
      <option value="0" '.$sel_local.'>local</option>
      <option value="1" '.$sel_obli.'>obligatoire - profil</option>
      <option value="2" '.$sel_obli2.'>obligatoire - profil2</option>
      </select>
      </td><td>
      <input type=hidden name=is_admin value=1>
      <input type=hidden name=value value=profil>
      <input type=hidden name=uid value='.$uid.'>
      <input type="submit" name="action" value="Appliquer">
      </td></tr></form>';
 
#      // cas particulier : le modèle Windows !
#      $buffer.= "<form method=post><tr><td>Modèle Windows</td><td>
#                <table width=\"100%\"><tr><td>[<b>";
#      $buffer.=`/usr/share/eole/backend/attribue-modele.py -u $uid`;
#      $buffer.="</b>]</td><td><center>";
#      $buffer.=liste_modeles("value","SUPPR");
#      $buffer.="</td></tr></table>";
#      $buffer.= "</td><td><input type=hidden name=uid value=\"$uid\">
#		   <input type=hidden name=is_admin value=\"$is_admin\">
#		 <input type=submit name=action value=\"Appliquer\">
#		 </td></tr></form>";

      // encore un cas particulier : le responsable de classe !
      $already = array();
      if ($attrs["typeadmin"][0]=="2") {
         foreach(($attrs["Divcod"]) as $key => $classe) {
	    if ("$key" == 'count') continue;
	    $already[] = $classe;
            $buffer.="<form method=post><tr><td>Administrateur de la classe<td>
	           <input type=\"text\" name=\"dd\" value=".$classe." size=\"33\" disabled></td><td>
	           <input type=hidden name=value value=\"$key\">
	           <input type=hidden name=uid value=\"$uid\">
		   <input type=hidden name=is_admin value=\"$is_admin\">
		   <input type=hidden name=already value=\"".$attrs["Divcod"]["count"]."\">
		   <input type=hidden name=action value=\"Revoque\">
		   <input type=submit name=sub value=\"Révoquer\"></td></tr></form>";
         }
      }
      $buffer.="<form method=post><tr><td>Classes à administrer<td>&nbsp";
	           if ($liste_groupe=list_group("","Classe")) {
		      $buffer .= "<select name=value>";
                      foreach ($liste_groupe as $groupe) {
		         if (!in_array($groupe,$already)) {
                            $buffer .= "<option value=\"$groupe\">$groupe</option>";
			 }
	              }
		      $buffer .= "</select>";
		   }
	           $buffer .= "</td><td>
	           <input type=hidden name=uid value=\"$uid\">
		   <input type=hidden name=is_admin value=\"$is_admin\">
		   <input type=hidden name=already value=\"".count($already)."\">
		   <input type=hidden name=action value=\"Nomme\">
		   <input type=submit name=sub value=\"Nommer\">
		   </td></tr></form>";
      // fin des informations

      // gestion des groupes
      $buffer.= choix_groupes("Groupes","Groupe",$uid,$is_admin);
      $buffer.= choix_groupes("Matières","Matiere",$uid,$is_admin);
      $buffer.= choix_groupes("Equipes pédagogiques","Equipe",$uid,$is_admin);
      $buffer.= choix_groupes("Groupes spéciaux","Administrateurs",$uid,$is_admin);
      // fin gestion
      
      $buffer .= "</table>";
      ldap_close($ds);
   }

   return $buffer ;
}
	  

// affichage des préférences d'un professeur
function view_preferences ($uid) {

   global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,
   $branch_admin,$ldap_objclass_admin,$autres_groupes;
   
   // connexion à l'annuaire
   $ds=connexion_ldap();
   // lecture (branche prof)
   $r = @ldap_read($ds,"uid=$uid,$branch_admin","objectclass=$ldap_objclass_admin");
   // test attributs
   if (@ldap_count_entries($ds,$r)<=0) {
      return ("ERREUR : le professeur $uid n'a pas été trouvé");
   }
   // normalement une seule entrée 
   $entry = ldap_first_entry($ds, $r);
   // récup des infos
   $attrs = ldap_get_attributes($ds, $entry);
   
   $buffer.= "<table>";
   // affichage des informations prof
   $buffer.= champ_non_modifiable("Identifiant",$attrs["uid"][0]);
   //$buffer.= champ_modifiable("Nom",$attrs["sn"][0],"sn",$uid,$is_admin);
   //$buffer.= champ_modifiable("Prénom",$attrs["givenName"][0],"givenName",$uid,$is_admin);
   
   // gestion du mail
   include "champmail.php";

   // encore un cas particulier : le responsable de classe !
   if ($attrs["typeadmin"][0]=="2") {
      if ($attrs["Divcod"]["count"] == 1) {
         $buffer.="<tr><td>Responsable de la classe<td>".$attrs["Divcod"][0]."</td></tr>";
      } else {
          $buffer.="<tr><td>Responsable des classes<td>".$attrs["Divcod"][0];
	  for($i=1;$i<$attrs["Divcod"]["count"];$i++) {
	     if ($i == ($attrs["Divcod"]["count"]-1)) $buffer.=" et ".$attrs["Divcod"][$i];
	     else $buffer.=", ".$attrs["Divcod"][$i];
	  }
	  $buffer.="</td></tr>";
      }
   }
   // fin des informations

      // gestion des groupes
      $buffer.= choix_groupes("Groupes","Groupe",$uid,$is_admin,1);
      $buffer.= mes_groupes("Matières","Matiere",$uid,$is_admin);
      $buffer.= mes_groupes("Equipes pédagogiques","Equipe",$uid,$is_admin);
      // fin gestion
      
   $buffer .= "</table>";
   ldap_close($ds);

   return $buffer ;
}
	  
    

    
   



function view_user_old ($uid, $is_admin)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve,$ldap_objclass_eleve, $branch_admin,$ldap_objclass_admin,$autres_groupes;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
     $buffer = "Can't connect to Ldap server ($ds)\n";
     // exit();
    } else {
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {

	  if($is_admin == 0)
	    {
	      $r = @ldap_read($ds,"uid=$uid,$branch_eleve","objectclass=$ldap_objclass_eleve");
	      $attributs_a_afficher=attributs_eleves();
	    }else{
	      $r = @ldap_read($ds,"uid=$uid,$branch_admin","objectclass=$ldap_objclass_admin");
	      $attributs_a_afficher=attributs_admin();
	    }
	    
	  if (@ldap_count_entries($ds,$r)<=0)
	    {
	      $buffer = "L'utilisateur n'existe pas\n";
	      // exit();
	      
	    } else {

	      $entry = ldap_first_entry($ds, $r);

	      $attrs = ldap_get_attributes($ds, $entry);

              $modifiable = attributs_modifiables();
              
	      $buffer = "Edition d'un utilisateur";
	      $buffer .= "<table>";
	      
	      foreach ($attributs_a_afficher as $nom_attribut => $libelle)
	      {
	         $val=$attrs[$nom_attribut][0]; // valeur de l'attribut
		 
		 if ($modifiable[$nom_attribut] == 'non')
		 // champs non modifiables
		 {
	             // enco
		     $buffer .= "<tr><td>$libelle</td>";
		     // meme pas besoin de form et compagnie !
		     $buffer .= "<td><input type=\"text\" name=\"value\" ";
		     $buffer .= "value=\"$val\" size=\"40\" disabled></td></tr>";
		 }
		 elseif ($modifiable[$nom_attribut] == 'oui')
		 {
		     // champs modifiables => FORM
		     $buffer .= "<form method=post>";
		     $buffer .= "<tr><td>$libelle</td><td>";
		     // toujours la petite exception qui confirme la règle... 
		     if ($nom_attribut == "dateNaissance") $val=formate_date($val);
		     $buffer .= "<input type=\"text\" name=\"value\" value=\"$val\" ";
		     $buffer .= "size=\"40\"></td><td>";
		     // champs cachés pour passage d'informations
		     $buffer .= "<input type=hidden name=attribute value=\"$nom_attribut\">";
		     $buffer .= "<input type=hidden name=uid value=\"$uid\">";
		     // on travaille avec des attributs MONO-VALUES ici 
		     $buffer .= "<input type=hidden name=index value=\"0\">";
		     $buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
		     $buffer .= "<input type=submit name=action value=\"Modifier\">";
		     $buffer .= "</td></tr></form>";
	         }	 
		 else 
		 {
		     $buffer .= "<tr><td>PROBLEME</td><td>$nom_attribut modifiable ?</td></tr>";
		 }
	      }// fin pour
/*
	      $buffer = "Edition d'un utilisateur";
	      $buffer .= "<table>";
	      for ($i=0; $i<$attrs["count"]; $i++)
	      {
		  
		  $values = ldap_get_values($ds, $entry,$attrs[$i]);

		  for ($j=0; $j < $values["count"]; $j++)
		  {
		  // joel => on n'affiche que les attributs ayant un libellé !
		  // cf. : libadmin-ldap.php
		      $attr_name = name_attributes($attrs[$i]);
		      if ($attr_name) {

		        if (( $attr_name != "cn") )
		      	{    
			  // Champs NON modifiables
			  if (( $attr_name == "Identifiant") || ( $attr_name =="Adresse Email")
			        || ($attr_name == "Classe" || $attr_name == "Niveau")) 
			  {
			        $buffer .= "<form>";
			        $buffer .= "<tr><td>$attr_name</td><td><input type=\"text\" name=\"value\" value=\"$values[$j]\" size=\"40\" disabled>";
			        $buffer .= "<input type=hidden name=attribute value=\"$attrs[$i]\">";
			        $buffer .= "<input type=hidden name=uid value=\"$uid\">";
			        $buffer .= "<input type=hidden name=index value=\"$j\">";
			        $buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
			        $buffer .= "</td></tr></form>";
		      
		          }else{	
		            // champs type mot de passe
			    if ( $attr_name == "userPassword")
			    {
		      		$buffer .= "<form>";
		      		$buffer .= "<tr><td>$attr_name</td><td><input type=\"password\" name=\"value\" value=\"$values[$j]\" size=\"40\"></td><td>";
		      		$buffer .= "<input type=hidden name=attribute value=\"$attrs[$i]\">";
		      		$buffer .= "<input type=hidden name=uid value=\"$uid\">";
		      		$buffer .= "<input type=hidden name=index value=\"$j\">";
		      		$buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
		      		$buffer .= "<input type=submit name=action value=\"Modifier\">";
		      		$buffer .= "</td></tr></form>";
			    }else{
			    // autres champs
			       	$buffer .= "<form>";
		      		$buffer .= "<tr><td>$attr_name</td><td><input type=\"text\" name=\"value\" value=\"$values[$j]\" size=\"40\"></td><td>";
				$buffer .= "<input type=hidden name=attribute value=\"$attrs[$i]\">";
		      		$buffer .= "<input type=hidden name=uid value=\"$uid\">";
		      		$buffer .= "<input type=hidden name=index value=\"$j\">";
		      		$buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
		      		$buffer .= "<input type=submit name=action value=\"Modifier\">";
		      		$buffer .= "</td></tr></form>";
		      	    }
			 }
		      }}
		   }
		}// fin pour

// Tout ça disparait puisque si NON BEUG : groupes principaux <=> classe,niveau
/*		if ($groupe_ppal=list_group($uid,"C")) {
		   // on admet que le groupe ppal EXISTE !
		   $buffer .= "<tr><td>Groupe principal</td><td><input type=\"text\" name=\"value\" value=\"".$groupes[$gid][0]."\" size=\"40\" disabled></td><td>";*/
	      
	      // Autres groupes modifiables...

	// les élèves n'ont besoin que de groupe Groupe ?
	if($is_admin == 0) {
	unset($autres_groupes);
	$autres_groupes["Groupe"]="Groupe";
	}

	      
	      foreach ($autres_groupes as $gp => $lib) {
	        $motif=" ---- ";
		$buffer .= "<tr><td colspan=3><center>$motif".$lib."s$motif</td></tr>";
		if ($groupes=list_group($uid,$gp)) {
		  foreach ($groupes as $number => $groupe)
		  {
		     //if ($number!=$gid){
		     // groupes secondaires
		     // pour les groupes : uid=uid, attribute=gid, index=?, $value=?, action=ACTION 
			$buffer .= "<form method=post>";
		        $buffer .= "<tr><td>$gp</td><td><input type=\"text\" name=\"value\"
			value=\"".$groupe."\" size=\"40\" disabled></td><td>";
			$buffer .= "<input type=hidden name=uid value=\"$uid\">";
		      	$buffer .= "<input type=hidden name=attribute value=\"".$groupe."\">";
		      	$buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
		        $buffer .= "<input type=hidden name=action value=\"SuppGroupe\">"; // feinte !
		        $buffer .= "<input type=submit name=index value=\"Désinscrire\">";
		      	$buffer .= "</td></tr></form>";
		   }//fin parcours autre groupes
		}else {
		   $buffer.="<tr><td colspan=3><center><i>L'utilisateur $uid n'appartient à aucun groupe $lib</i></td></tr>";
		}
		   
		// liste des groupes existants
		$tous=list_group("",$gp);

		// groupes existants dans lesquels l'utilisateur n'est pas
                if ($out=array_diff($tous,$groupes)) {
		   $buffer .= "<form method=post>";
		   $buffer .= "<tr><td>".$lib." disponibles</td><td><select name=\"attribute\">";
		   foreach ($out as $groupe) {
		      $buffer .= "<option value=\"$groupe\">$groupe</option>";
		   }
		   $buffer .= "</select>";
		   $buffer .= "</td><td>";
		   $buffer .= "<input type=hidden name=uid value=\"$uid\">";
		   $buffer .= "<input type=hidden name=value value=\"/\">";
		   $buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
		   $buffer .= "<input type=hidden name=action value=\"AddGroupe\">"; // feinte !
		   $buffer .= "<input type=submit name=index value=\"&nbsp Inscrire&nbsp&nbsp\">";
		   $buffer .= "</td></tr></form>";
		}
		else {
		   $buffer.="<tr><td colspan=3><i>Plus de $gp disponible</i></td></tr>";
		}
	      }//fin pour autres_groupes
	        $buffer .= "</table>";
	    }// fin pour2
	}
    }

  
  ldap_close($ds);
  return $buffer ;
}


function modify_user_attribute($uid, $attribute, $value, $index, $is_admin)
{
 
    global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base,$ldap_objclass_eleve,$branch_eleve, $ldap_objclass_admin,$branch_admin;

    //connection 
    $ds=ldap_connect($ldap_server,$ldap_port);
    if (!$ds)
      {
	$buffer = "Can't connect to Ldap server ($ds)\n";
	// exit();
      } else {
    
	//bind
	$r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
	if (!$r)
	  {
	    $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	    // exit();
	  } else {

	    //lire
	    if($is_admin == 0)
	      {
		$r = @ldap_read($ds,"uid=$uid,$branch_eleve","objectclass=$ldap_objclass_eleve");
	      }else{
		$r = @ldap_read($ds,"uid=$uid,$branch_admin","objectclass=$ldap_objclass_admin");
	      }	
	    
	    if (@ldap_count_entries($ds,$r)<=0)
	      {
		ldap_close($ds);
		return;
	      }
	    $e = ldap_first_entry($ds,$r);
 
	    $values = ldap_get_values($ds,$e,$attribute);
	    for ($i=0;$i<$values["count"];$i++)
	      {
		if ($i == $index)
		  {
		    $value = replace_carac($value);
		    $entry[$attribute][$i]="$value";
		    $entry[$attribute][$i]=replace_carac($entry[$attribute][$i]);
		  } else {
		    $values[$i] = replace_carac($values[$i]);
		    $entry[$attribute][$i]=$values[$i];
		    $entry[$attribute][$i]=replace_carac($entry[$attribute][$i]);
		  }
	      }

	    if($is_admin == 0)
	      {
		$r = ldap_modify($ds,"uid=$uid,$branch_eleve",$entry);
	      }else{
		$r = ldap_modify($ds,"uid=$uid,$branch_admin",$entry);
	      }
	    if (!$r)
	      {
		$buffer = pb($uid);
	      } else {
		$buffer = ok($uid);
	      }
	  }
      }

  ldap_close($ds);
  return $buffer ;
}


function add_user_attribute($uid, $attribute, $value, $index, $is_admin)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass_eleve, $branch_eleve, $ldap_objclass_admin, $branch_admin;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      // exit();
    } else {
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {

	  if($is_admin == 0)
	    {
	      $branche = $branch_eleve;
	      $r = ldap_read($ds,"uid=$uid,$branche","objectclass=$ldap_objclass_eleve");
	    }else{
	      $branche = $branch_admin;
	      $r = ldap_read($ds,"uid=$uid,$branche","objectclass=$ldap_objclass_admin");
	    }
	  if (ldap_count_entries($ds,$r)<=0)
	    {
	      ldap_close($ds);
	      return;
	    }

	  $entry[$attribute]=$value;
	  $r = ldap_mod_add($ds,"uid=$uid,$branche",$entry);  
	  
	  if (!$r)
	    {
	      $buffer = pb($uid);
	    } else {
	      $buffer = ok($uid);
	    }
	}
    }

  ldap_close($ds);
  return $buffer ;
}


function remove_user_attribute($uid, $attribute, $value, $index, $is_admin)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass_eleve, $branch_eleve, $ldap_objclass_admin, $branch_admin;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      /// exit();
    } else { 
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {
  
	  if($is_admin == 0)
	    {
	      $r = ldap_read($ds,"uid=$uid,$branch_eleve","objectclass=$ldap_objclass_eleve");
	    }else{
	      $r = ldap_read($ds,"uid=$uid,$branch_admin","objectclass=$ldap_objclass_admin");
	    }
  
	  if (ldap_count_entries($ds,$r)<=0)
	    {
	      ldap_close($ds);
	      return;
	    }

          $entry[$attribute]=array();
	  $e = ldap_first_entry($ds,$r);
	  $values = ldap_get_values($ds,$e,$attribute);
	  for ($i=0;$i<$values["count"];$i++)
	    {
	      #$buffer .= "$values[$i]  $index $attribute";
              // on garde les anciennes valeurs 
	      if ($i != $index) {
		$entry[$attribute][]=$values[$i];
		}
	    }
	  if($is_admin == 0)
	    {
	      $r = ldap_modify($ds,"uid=$uid,$branch_eleve",$entry);
	    }else{
	      $r = ldap_modify($ds,"uid=$uid,$branch_admin",$entry);
	    }
	  if (!$r)
	    {
	      $buffer = pb($uid);
	    } else {
	      $buffer = ok($uid);
	    }
	}
    }

  ldap_close($ds);
  return $buffer ;
}

// gestion des messages affichés
function pb($uid) {
   return "<font color=red>Un problèmes est survenu, l'utilisateur n'a pas été modifié.</font><br><br>";
}
function ok($uid) {
   return "<b>Le compte '$uid' a été modifié.</b><br><br>";
}


function replace_carac($buffer)
{
  $buffer = ereg_replace ( "è", "e", $buffer );
  $buffer = ereg_replace ( "é", "e", $buffer );
  $buffer = ereg_replace ( "ê", "e", $buffer );
  $buffer = ereg_replace ( "ë", "e", $buffer );
  $buffer = ereg_replace ( "à", "a", $buffer );
  $buffer = ereg_replace ( "â", "a", $buffer );
  $buffer = ereg_replace ( "ä", "a", $buffer );
  $buffer = ereg_replace ( "î", "i", $buffer );
  $buffer = ereg_replace ( "ï", "i", $buffer );
  $buffer = ereg_replace ( "ô", "o", $buffer );
  $buffer = ereg_replace ( "ö", "o", $buffer );
  $buffer = ereg_replace ( "ù", "u", $buffer );
  $buffer = ereg_replace ( "û", "u", $buffer );
  $buffer = ereg_replace ( "ü", "u", $buffer );

  return $buffer;
}


?>
