<?php
/*

  Librairie consacrée à la gestion des groupes LDAP
 
*/


global $PHP_AUTH_USER;


// renvoit la liste des groupes 
// si $user défini   : groupes de l'utilisateur
// si $type défini   : groupes particuliers (Classes, Niveaux, Groupes)
// si $chaine défini : motif recherché
// sinon tous les groupes existants
function list_group($user,$type,$chaine="",$mail="")
{
   global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin, $branch_groupe, $ldap_objclass_eleve, $PHP_AUTH_USER;
    
   // Conection a au serveur  
   $ds=ldap_connect($ldap_server,$ldap_port);
   if (!$ds) {
      print "Can't connect to Ldap server ($ds)\n";
      exit();
   }

   // Bind   
   $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
   if (!$r) {
      print "Can't bind to Ldap server (Perhaps a bad password ?)\n";
      exit();
   }
   
   // test des paramètres :

   // filtre minimum
   $dedans="(!(cn=samba*))(!(cn=Administrateurs))";
   
   // type de groupe particulier
   if ($type) {
      if ($type=="C") $type="classe";
      if ($type=="N") $type="niveau";
      if ($type=="G") $type="groupe";
      if ($type=="E") $type="equipe";
      if ($type=="M") $type="matiere";

      // avec motif ou sans
      if ($chaine) {
         $dedans.="(description=$type *$chaine*)";
      }
      else {
	 $dedans.="(description=$type *)";
      }
   }
   
   // groupes de l'utilisateur $user
   if ($user) {
      $dedans.="(memberUid=$user)";
   }
	       
   // concaténation des filtres
   $critere="(&$dedans)";
   
   // balance la requête
   $r = ldap_list($ds,$branch_groupe,$critere,array("cn","mail"));
   if (ldap_count_entries($ds,$r) > 0) {
      // tri par NOM du groupe
      ldap_sort ($ds, $r, "cn");
      $e = ldap_first_entry($ds,$r);
      do {
         //$gidnumber=ldap_get_values($ds,$e,"gidNumber");
	 $cn=ldap_get_values($ds,$e,"cn");
	 $tab[] = $cn[0];
	 $old=error_reporting(1);
	 $m=ldap_get_values($ds,$e,"mail");
         error_reporting($old);
	 $tmail[$cn[0]]=$m[0];
      } while (($e=ldap_next_entry($ds,$e)));
   }
   else {
      // tableau vide 
      $tab=array();
   }
   ldap_close($ds);
   // trié, c'est mieux
   //sort($tab);
   if ($mail) return (array($tab,$tmail)) ;
   else return ($tab) ;
}	    


// liste des partages
function list_share()
{
   // très important !
   global $racine, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn;
    
   // Conection a au serveur  
   $ds=ldap_connect($ldap_server,$ldap_port);
   if (!$ds) {
      print "Can't connect to Ldap server ($ds)\n";
      exit();
   }
   $dn = "ou=local,ou=partages,$racine";
   $filtre="(objectClass=sambaFileShare)";
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort($ds,$sr,"description");
   $info = ldap_get_entries($ds, $sr);
   for ($i=0; $i<$info["count"]; $i++){
       $share= $info[$i]["sambasharename"][0];
       $buf.="<option value=$share>$share</option>";
   }
   ldap_close($ds);
   return($buf);
}

// renvoit la liste des membres d'un groupe  
function membre_group($gid,$type)
{
   global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin, $branch_groupe, $ldap_objclass_eleve, $PHP_AUTH_USER;
    
   //Connection a au serveur  
   $ds=ldap_connect($ldap_server,$ldap_port);
   if (!$ds) {
      print "Can't connect to Ldap server ($ds)\n";
      exit();
   }
      
   //Bind   
   $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
   if (!$r) {
      print "Can't bind to Ldap server (Perhaps a bad password ?)\n";
      exit();
   }

   // traitement
   
   if ($gid){
      if ($type) {
         if ($type=="C") $type="classe*";
         if ($type=="N") $type="niveau*";
         if ($type=="G") $type="groupe*";
	    $critere="(&(cn=$gid)(description=$type))";
      }else{
         $critere="(cn=$gid)";
      }
	    
      $r = ldap_list($ds,$branch_groupe,$critere,array("memberUid"));
      
      $e = ldap_first_entry($ds,$r);
      $att=ldap_get_attributes($ds,$e);
      $tab=$att["memberUid"];
   }
   ldap_close($ds);
   
   // trié, c'est mieux
   if ($tab) array_multisort($tab);
   
   return $tab ;
}	    


// renvoit le niveau correspondant à la classe en question
function niveau($classe)
{
  global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin, $branch_groupe, $ldap_objclass_eleve, $PHP_AUTH_USER;
    
  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
       print "Can't connect to Ldap server ($ds)\n";
       exit();
    } else {
      //Bind   
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
      {
	  print "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  exit();
      } else {
         if ($classe){
	    $critere="(&(objectClass=classe)(cn=$classe))";
	    $r = ldap_list($ds,$branch_groupe,$critere);
	    if (ldap_count_entries($ds,$r) > 0)
	    {
	      $e = ldap_get_entries($ds,$r);
	      return($e[0]["niveau"][0]);
	    }
	 }
      }
    }
   ldap_close($ds);
   return $tab ;
}	    

// renvoit les classes correspondant à un niveau
function classes($niveau)
{
  global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin, $branch_groupe, $ldap_objclass_eleve, $PHP_AUTH_USER;
    
  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
       print "Can't connect to Ldap server ($ds)\n";
       exit();
    } else {
      //Bind   
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
      {
	  print "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  exit();
      } else {
         if ($niveau){
	    $critere="(&(objectClass=classe)(niveau=$niveau))";
	    $r = ldap_list($ds,$branch_groupe,$critere);
	    if (ldap_count_entries($ds,$r) > 0)
	    {
	       $e = ldap_first_entry($ds,$r);
	       do
	       {
	          $tab[]=ldap_get_values($ds,$e,"cn");	
	       } while (($e=ldap_next_entry($ds,$e)));
               ldap_close($ds);
               return $tab ;
	    }
	    ldap_close($ds);
	 }
      }
    }
}	    


// liste des élèves (uid) d'une classe
// utile pour éviter que le prof se retrouve dans l'affaire !
function eleves_de($classe)
{
   global $branch_eleve;
   $ds=connexion_ldap();
   $dn=$branch_eleve;
   $filtre="(Divcod=$classe)";
   $r = ldap_list($ds,$dn,$filtre);
   if (ldap_count_entries($ds,$r) > 0) {
      $e = ldap_first_entry($ds,$r);
      do { 
         $tab[]=ldap_get_values($ds,$e,"uid");
      } while (($e=ldap_next_entry($ds,$e)));
      ldap_close($ds);
      return $tab ;
   }
}

// liste des comptes mails
function mail_accounts()
{
   global $racine;
   $ds=connexion_ldap();
   $dn="ou=mails,ou=utilisateurs,$racine";
   $filtre="(mail=*)";
   $r = ldap_list($ds,$dn,$filtre);
   if (ldap_count_entries($ds,$r) > 0) {
      $e = ldap_first_entry($ds,$r);
      do {
         $uid=ldap_get_values($ds,$e,"uid");
	 $mail=ldap_get_values($ds,$e,"mail");
         $tab[$uid[0]]=$mail[0];
      } while (($e=ldap_next_entry($ds,$e)));
      ldap_close($ds);
      asort($tab);
      return ($tab) ;
   }
}

// liste des professeurs responsables de classe
// on peut restreindre aux classes contenant $motif
function responsables($motif="")
{
   global $branch_admin;
   $ds=connexion_ldap();
   $dn=$branch_admin;
   $filtre="(Typeadmin=2)";
   $r = ldap_list($ds,$dn,$filtre,array('uid','Divcod'));
   if (ldap_count_entries($ds,$r) > 0) {
      // tri par NOM de CLASSE
      #ldap_sort ($ds, $r, "Divcod");
      $e = ldap_first_entry($ds,$r);
      do { 
         $cl=ldap_get_values($ds,$e,"Divcod");
	 foreach($cl as $key => $classe) {
	    // motif de recherche classe
	    if ("$key"!='count' and preg_match("/$motif/",$classe)) {
               $uid=ldap_get_values($ds,$e,"uid");
               $tab[$classe][] = $uid[0];
	    }
	 }
      } while (($e=ldap_next_entry($ds,$e)));
      ldap_close($ds);
      return $tab ;
   }
}

// liste des modèles existants
function liste_modeles($nom_liste,$defaut="- sélectionnez -")
{
   $sel="<select name=\"$nom_liste\">";
   // option vide
   if ($defaut=="SUPPR")
      $sel.="<option value=\"SUPPR\">-- AUCUN --</option>";
   else 
      $sel.="<option value=\"\">$defaut</option>";
   $handle=opendir('./modeles/groupes');
   while ($file = readdir($handle)) {
      if ($file != "." && $file != "..") {
         $sel.="<option value=\"$file\">$file</option>";
      }
   }
   closedir($handle);
   $sel.="</select>";
   return $sel;
}

// parsing à la hache du fichier XML de définition des clés de registres 
// fonction inspirée de http://www.asp-php.net/ressources/bouts_de_code.php?codid=43
function lit_xml($fichier,$champs) {
   // on lit le fichier
   if($chaine = @implode("",@file($fichier))) {
      // parcours des catégories
      $cats = preg_split("/<\/?Categorie>/",$chaine);
      for($i=1;$i<sizeof($cats)-1;$i+=2) {
         // récupération du nom de la catégorie ($cat[1])
         $cat = preg_split("/<\/?Nom>/",$cats[$i]);
	 // parcours des règles
	 $regs = preg_split("/<\/?Regle>/",$cats[$i]);
         for($j=0;$j<sizeof($regs)-1;$j++) {
	    // remplissage des champs
	    foreach($champs as $champ) {
	       $t_champs = preg_split("/<\/?".$champ.">/",$regs[$j]);
	       //print @$t_champs[1];
	       $res[$cat[1]][$j-1][]=@$t_champs[1];
	    }
	 }	 
      }
      return($res);
   }
}

// fabrication des boutons radio oui/non pour l'édition d'un modèle
function radio_mod($nom,$val)
{
   if ($val) {
      $check_oui="checked";
      $check_non="";
   }
   else{
      $check_oui="";
      $check_non="checked";
   }
   
   $ch="<td align=center width='15%'><input type=\"radio\" name=\"radio[$nom]\" value=\"1\" $check_oui></td>
        <td align=center width='15%'><input type=\"radio\" name=\"radio[$nom]\" value=\"0\" $check_non></td>";
   return $ch;
}

// lecture des règles utilisées par un groupe
function lire_modele($groupe)
{
    if (file_exists("./modeles/groupes/$groupe")) {
       $fd = fopen ("./modeles/groupes/$groupe", "r");
       while (!feof ($fd)) {
          $ligne = fgets($fd, 4096);
          list($cle,$valeur)= split ("#", $ligne,2);
          // au cas où avec les \n
          if ($cle) $tab[$cle]=$valeur;
       }
       fclose ($fd);
    }
    return $tab;
}

// écriture des règles utilisées par un groupe
function ecrire_modele($groupe,$regles)
{
   $filename="./modeles/groupes/$groupe";
   //if (!is_writable($filename)) {
   //   return 0;
   //}
   if (!$handle = fopen($filename, 'w')) {
      return 0;
   }
   foreach ($regles as $cle => $val) {
      $val=trim($val); // bug des ^M avec IE
      $val=stripslashes($val);
      // mini-traitement pour klaas
      if ($val != "") {
         // des "\" sont ajoutés automatiquement
	 fwrite($handle, "$cle#$val\n");
      }
   }
   fclose($handle);
   return 1;
}

// initialisation d'un nouveau modèle à partir d'un modèle existant
function duplique_modele($modele,$source)
{
   $path="./modeles/groupes/";
   if (file_exists("$path$modele") or (!file_exists("$path$source"))) return 0;
   return(copy("$path$source","$path$modele"));
}

?>
