<?php


// CENTRALISATION de la CONNEXION à l'ANNUAIRE
// à mettre en place progressivement !
function connexion_ldap()
{
   global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base;
   
   $ds=ldap_connect($ldap_server,$ldap_port);
   if (!$ds) {
      print("Impossible de se connecter à l'annaire LDAP\n"); exit();
   }
   $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
   if (!$r) {
      print("Impossible de s'authentifier auprès de l'annuaire, vérifiez le mot de passe\n"); exit();
   }
   // renvoit la connexion
   return($ds);
}
// fin Connexion //


function get_admin_class($user)
{
    global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ret;

  if(get_admin_level($user) == 0)
  {
	return 0;
  }
  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      print("Can't connect to Ldap server ($ds)\n"); exit();
    }
  $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
  if (!$r)
    {
      print("Can't bind to Ldap server (Perhaps a bad password ?)\n"); exit();
    }

//  $r = ldap_search($ds, $ldap_base, "sn=$user");
  $r = ldap_search($ds, $ldap_base, "uid=$user", array("Meflcf", "Divcod"));

  $info = ldap_get_entries($ds,$r);

  //$ret[0] = $info[0]["meflcf"][0] ;
  $classe = $info[0]["divcod"];
  unset($classe['count']);
  return $classe;
}

function get_admin_level($user)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      print("Can't connect to Ldap server ($ds)\n"); exit();
    }
  $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
  if (!$r)
    {
      print("Can't bind to Ldap server (Perhaps a bad password ?)\n"); exit();
    }

  $r = ldap_search($ds, $ldap_base, "uid=$user",array("typeadmin") );

  $info = ldap_get_entries($ds,$r);

  if ($info["count"] != 1) {
    return 1;
  }
  $typeadmin=$info[0]["typeadmin"][0];
  if ($typeadmin==1) return 0;
  if ($typeadmin==2) return 1;
  return 2;
}

function list_domain()
{
  global $domain_list;

  $buffer = "<option>tous les domaines</option>";
  for ($i=0; $i < count($domain_list); $i++)
   {
     $buffer .= "<option> $domain_list[$i]</option>"; 
   }
  
  return $buffer;
}

function list_domain_add()
{
   global $domain_list;
   /*for ($i=0; $i < count($domain_list); $i++){
     $buffer .= "<option> $domain_list[$i]</option>"; 
   }*/
   $buffer .= "<option value=\"restreint\"> ".$domain_list[0] ." </option>";
   $buffer .= "<option value=\"internet\"> ". $domain_list[1] ." </option>";
   return $buffer;
}



function list_branch()
{
  global $branch_list;


  for ($i=0; $i < count($branch_list); $i++)
    {
      $buffer .= "<option> $branch_list[$i]</option>";
    } 
 
  return $buffer;
}

function is_email_exist($email)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass, $ldap_grpclass;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
  {
    print("Can't connect to Ldap server ($ds)\n"); exit();
  }
  $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
  if (!$r)
  {
    print("Can't bind to Ldap server (Perhaps a bad password ?)\n"); exit();
  }

  $r = ldap_search($ds,"$ldap_base","(&(mail=$email)(objectclass=$ldap_objclass))");
  if (($count=ldap_count_entries($ds,$r))<=0)
  {
    # On teste pour les noms des groupes
    list($uid,$domain) = split ("@",$email);
    $r = @ldap_read($ds,"uid=$uid,o=$domain,$ldap_base","objectclass=$ldap_grpclass");
    if (!($r && ldap_count_entries($ds,$r)>0))
    {
      ldap_close($ds);
      return 0;
    }
  }

  ldap_close($ds);
  return 1;
}

function champ_non_modifiable($libelle, $val)
{
   return ("
    <tr><td>$libelle</td>
    <td><input type=\"text\" name=\"value\"
    value=\"$val\" size=\"33\" disabled></td></tr>
    ");
}
    
function champ_modifiable($libelle, $val, $nom_attribut, $uid, $is_admin)
{
   // exception DATE !
   if ($nom_attribut == "dateNaissance") $val=formate_date($val);
   
   return ("
    <form method=post>
    <tr><td>$libelle</td>
    <td><input type=\"text\" name=\"value\" value=\"$val\"
    size=\"33\"></td><td>
    <input type=hidden name=attribute value=\"$nom_attribut\">
    <input type=hidden name=uid value=\"$uid\">
    <input type=hidden name=index value=\"0\">
    <input type=hidden name=is_admin value=\"$is_admin\">
    <input type=submit name=action value=\"Modifier\">
    </td></tr></form>
    ");
}

function champ_civilite($libelle, $val, $nom_attribut, $uid, $is_admin)
{
    $buf = "<form method=post>
    <tr><td>$libelle</td>
    <td><select name=\"value\">";
    foreach (array('1'=>'M.', '2'=>'Mme', '3'=>'Mlle') as $value => $label) {
       if ($val == $value) $buf .= "<option value=$value SELECTED>$label</option>";
       else $buf .= "<option value=$value>$label</option>";
    }
    $buf .= "</select></td><td>
    <input type=hidden name=attribute value=\"$nom_attribut\">
    <input type=hidden name=uid value=\"$uid\">
    <input type=hidden name=index value=\"0\">
    <input type=hidden name=is_admin value=\"$is_admin\">
    <input type=submit name=action value=\"Modifier\">
    </td></tr></form>
    ";
   return $buf;
}

// groupes de l'utilisateur et groupes disponibles
// si pref=1 : il faut changer les libellés !
function choix_groupes($lib,$gp,$uid,$is_admin,$pref=0) 
{
   $motif=" ---- ";
   $buffer = "<tr><td colspan=3><center>$motif".$lib."$motif</td></tr>";
   if ($groupes=list_group($uid,$gp)) {
      foreach ($groupes as $groupe)
      {
         $buffer .= "<form method=post>";
	 $buffer .= "<tr><td>$gp</td><td><input type=\"text\" name=\"value\"
	 value=\"".$groupe."\" size=\"33\" disabled></td><td>";
	 $buffer .= "<input type=hidden name=uid value=\"$uid\">";
	 $buffer .= "<input type=hidden name=attribute value=\"".$groupe."\">";
	 $buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
	 $buffer .= "<input type=hidden name=action value=\"SuppGroupe\">"; // feinte !
	 if ($pref) $buffer .= "<input type=submit name=index value=\"Me désinscrire\">";
	 else $buffer .= "<input type=submit name=index value=\"Désinscrire\">";
	 $buffer .= "</td></tr></form>";
      } //fin parcours groupes
   }
   else {
      $buffer.="<tr><td colspan=3><center><i>";
      if ($pref) $buffer.= "Vous n'appartenez à aucun groupe '$lib'";
      else $buffer.= "L'utilisateur $uid n'appartient à aucun groupe $lib";
      $buffer.="</i></td></tr>";
   }
   
   // liste des groupes existants   
   $tous=list_group("",$gp);
   // groupes existants dans lesquels l'utilisateur n'est pas
   if (!is_array($groupes)) $groupes=array();
   if (!is_array($tous)) $tous=array();
   if ($out=array_diff($tous,$groupes)) {
      // plus qu'à afficher
      $buffer .= "<form method=post>";
      $buffer .= "<tr><td>".$lib." disponibles</td><td><select name=\"attribute\">";
      foreach ($out as $groupe) {
         $buffer .= "<option value=\"$groupe\">$groupe</option>";
      }
      $buffer .= "</select>";
      $buffer .= "</td><td>";
      $buffer .= "<input type=hidden name=uid value=\"$uid\">";
      //$buffer .= "<input type=hidden name=value value=\"/\">";
      $buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
      $buffer .= "<input type=hidden name=action value=\"AddGroupe\">"; // feinte !
      if ($pref) $buffer .= "<input type=submit name=index value=\"M'inscrire&nbsp\">";
      else $buffer .= "<input type=submit name=index value=\"&nbsp Inscrire&nbsp&nbsp\">";
      $buffer .= "</td></tr></form>";
   }
   else {
      $buffer.="<tr><td colspan=3><i>Plus de $gp disponible</i></td></tr>";
   }
   return ($buffer);
}
     
function mes_groupes($lib,$gp,$uid,$is_admin) 
{
   $motif=" ---- ";
   $buffer .= "<tr><td colspan=3><center>$motif".$lib."$motif</td></tr>";
   if ($groupes=list_group($uid,$gp)) {
      foreach ($groupes as $groupe)
      {
         //$buffer .= "<form>";
	 $buffer .= "<tr><td>$gp</td><td><input type=\"text\" name=\"value\"
	 value=\"".$groupe."\" size=\"33\" disabled></td><td>";
      } //fin parcours groupes
   }
   else {
      $buffer.="<tr><td colspan=3><center><i>L'utilisateur $uid n'appartient à aucun groupe $lib</i></td></tr>";
   }
   return ($buffer);
}
     



function name_attributes($attr)
{
  if ($attr == 'sn')
    return "Nom de la personne";
  else if ($attr == 'mail')
    return "Adresse Email";
  //else if ($attr == 'description')
  //  return "Description";
  else if ($attr == 'userpassword')
    return "Mot de passe MESSAGERIE";
  else if ($attr == 'maildrop')
    return "Destination";
  else if ($attr == 'uid')
    return "Identifiant";
  else if ($attr == 'allowedservices')
    return "Service autorisés";
  else if ($attr == 'givenName')
    return "Prénom";
  else if ($attr == 'codecivilite')
    return "Civilité";
  else if ($attr == 'postalAddress')
    return "Adresse postale";
  else if ($attr == 'employeeNumber')
    return "Numéro Eleve/Personnel";
  else if ($attr == 'dateNaissance')
    return "Date de naissance";
  else if ($attr == 'Meflcf')
    return "Niveau";
  else if ($attr == 'Divcod')
    return "Classe";
  else if ($attr == 'Divcodmso')
    return "Dernière division scolaire";
  else if ($attr == 'mailForwardingAddress')
    return "Adresse de redirection";
  // ajouts de paramètres pour serveur fichiers ?
  //else if ($attr == 'homeDirectory')
  //  return "Répertoire personnel";
  //else if ($attr == 'gidNumber')
  //  return "Groupe principal";
  else
    return "";
  
}

// existance d'une entrée machin de type truc
function existe($machin,$truc)
{
   // très important !
   global $racine;
      
   $ds=connexion_ldap();
   $dn = "ou=local,ou=$truc,$racine";
   $filtre="(cn=$machin)";
   $sr = ldap_search($ds,$dn,$filtre);
   $info = ldap_get_entries($ds, $sr);
   ldap_close($ds);
   if ($info['count']==0){
      return (0);
   }
   else{
      return (1);
   }
}	 


function liste_stations()
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=ordinateurs,ou=ressources,$racine";
   // à cet endroit sont stockés le serveur et les éventuelles stations
   $filtre="(|(!(objectClass=sambaServer))(objectClass=posixAccount))";
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort ($ds, $sr, "uid");
   $info = ldap_get_entries($ds, $sr);
   $buf='';
   for ($i=0; $i<$info["count"]; $i++){
      //if ($info[$i]["uid"][0] != $info[$i]["cn"][0]) {
      //   print "Attention : incohérence entre l'uid et le cn pour ".$info[$i]["uid"][0]."<br>";
      //}
      $stat1= $info[$i]["uid"][0];
      $stat2= $info[$i]["cn"][0];
      $buf.="<option value=$stat2>$stat1</option>\n";
   }
   ldap_close($ds);
   return($buf);
}
   
?>
