<?php
/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */

global $PHP_AUTH_USER;

//affiche la liste des users suivant la branche et le domaine selectionné
function list_user($domain, $branch)
{
  global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin ,$ldap_objclass_eleve, $PHP_AUTH_USER;

    
  //Conection a au serveur  
  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      // exit();
    } else {
      
      //Bind   
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {

	  //list 
	  //   $plop="$branch_eleve,$ldap_base";
	  //   print $branch_eleve;
	  //    $r = ldap_list($ds,$branch_eleve,"objectclass=$ldap_objclass_eleve");
	  $is_admin=0;
	  if ($branch != "")
	    {
	     
	      if($branch == "eleves")
		{

		  if ($domain == "tous les domaines")
		    {
		      $r = ldap_list($ds,$branch_eleve,"mail=*@*");
		    } else {
		      $r = ldap_list($ds,$branch_eleve,"mail=*@$domain");	   
		    }
		}else{
		
		  if($branch == "administrateur")
		    {
		
		      if ($domain == "tous les domaines")
			{
			  $r = ldap_list($ds,$branch_admin,"mail=*@*");
			} else {
			  $r = ldap_list($ds,$branch_admin,"mail=*@$domain");
			}
		      $is_admin=1;
		    }
		}
	    
	    } else {
	     
	      $cl_filter = "";
              foreach (get_admin_class($PHP_AUTH_USER) as $classe) {
	         # construction du filtre sur les classes du prof
		 $cl_filter.="(Divcod=$classe)";
	      }
	      if ($domain == "tous les domaines")
		{
		  $r = ldap_list($ds,$branch_eleve,"(&(mail=*@*)(!$cl_filter))"); 
		} else {
		  $r = ldap_list($ds,$branch_eleve,"(&(mail=*@$domain)(!$cl_filter))");
		}
	    }
	  
	  //etape pour avoir la listes users de toutes les branches
	  if ($branch == "toutes les branches")
	    {
	     
	        if ($domain == "tous les domaines")
		{
		
		  $buffer2 = "Eleves<br>";
		  $is_admin = 0 ;
		  $r = ldap_list($ds, $branch_eleve,"mail=*@*");
		  $buffer2 .= processus_list($ds, $r, $is_admin, $buffer);
		  $buffer2 .= "<br>Administrateurs<bR>";
		  $is_admin = 1;
		  $r = ldap_list($ds,$branch_admin,"mail=*@*");
		  $buffer2 .= processus_list($ds, $r, $is_admin, $buffer);
		
		} else {
		  $buffer2 = "Eleves<br>";
		    $is_admin = 0;
		  $r = ldap_list($ds, $branch_eleve, "mail=*@$domain");
		  $buffer2 .= processus_list($ds, $r, $is_admin, $buffer);
		  
		  $buffer2 .= "<br>Administrateurs<br>";
		  $is_admin = 1;
		  $r = ldap_list($ds,$branch_admin,"mail=*@$domain");
		  $buffer2 .= processus_list($ds, $r, $is_admin, $buffer); 
		}
	      
	 
	    } else {
	      $buffer2 .= processus_list($ds, $r, $is_admin, $buffer);
	      
	    }
	}
    }
	  ldap_close($ds);
	  return $buffer2 ;
}	    



//processus de listing en tenant compte des parametres données par la fonction list_user (la branche , le domaine demandés)
function processus_list($ds, $r, $is_admin, $buffer)
{
global $PHP_AUTH_USER;
  
  if (ldap_count_entries($ds,$r)<=0)
		     {
		       $buffer .=  "aucune entrée <br>";
		       
		     } else {
		       

		       $buffer .= "<table border=1>";
		       $e = ldap_first_entry($ds,$r);
		       do
			 {
			   $cn =  ldap_get_values($ds,$e,"cn");
			   $email = ldap_get_values($ds,$e,"mail");
			   $uid = ldap_get_values($ds,$e,"uid");
			   
			   if ($is_admin == 1)
			     {
			       $typeadmin = ldap_get_values($ds,$e,"typeadmin");
			     }
			   //    $meflcl=ldap_get_values($ds,$e,"Meflcl");
			   //  $$divcod=ldap_get_values($d,$e,"Divcod");
			   $buffer .= "<tr><td>$cn[0] &lt;$email[0]&gt;</td>";
			  
			   //en fait apres reflexion, les admin n'ont pas a savoir le password des users
			   // $buffer .="<td><a href=\"change-pwd-ldap.php?uid=$uid[0]&is_admin=$is_admin\">changer le mot de passe</a></td>";
			   if (get_admin_level($PHP_AUTH_USER) != 1)
			     {
		
			   $buffer .= "<td><a href=\"edit-user-ldap.php?uid=$uid[0]&is_admin=$is_admin\">Editer</a></td>";
			     }
			   
			   //empecher l'effacement d'un "super" admin de classe
			   if ( $typeadmin[0] != 1)
			     {
			  
			       $buffer .= "<td><a href=\"remove-user-ldap.php?uid=$uid[0]&is_admin=$is_admin\">Effacer</td>";  
			     }
			   //empecher de changer de domaine de mail pour tous les administrateurs
			   if ($is_admin != 1) 
			     {
			  
			       $buffer .= "<td><a href=\"change-domain-mail.php?uid=$uid[0]&is_admin=$is_admin\">changer domaine mail</td>";
			     }
			   $buffer .= "<tr>";
			 } while (($e=ldap_next_entry($ds,$e)));
		       
		       $buffer .= "</table>";
		     }

 return $buffer ;
}


/*==========================================================================================================================================================================================================
                                         fonctions spéciales admintop
=====================================================================================================*/


//fonction pour les lister les boites: cas admintop
function list_user_admintop($domain, $branch, $letter, $booleen)
{
  global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin ,$ldap_objclass_eleve, $PHP_AUTH_USER, $request_ldap;

    
  //Conection a au serveur  
  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      // exit();
    } else {
      
      //Bind   
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {

	      $is_admin=0;
	      if ($branch != "")
	      {
		// les admin de classe se retrouvent aussi dans cette fonction pour pouvoir éditer
		// leurs élèves (Joel)
		if(get_admin_level($PHP_AUTH_USER) != 0)
		{
		
                   $cl_filter = "";
                   foreach (get_admin_class($PHP_AUTH_USER) as $classe) {
                      # construction du filtre sur les classes du prof
                      $cl_filter.="(Divcod=$classe)";
                   }
                   if ($domain == "tous les domaines"){
                       $r = ldap_list($ds,$branch_eleve,"(&(mail=*@*)(!$cl_filter))"); 
                   } else {
                       $r = ldap_list($ds,$branch_eleve,"(&(mail=*@$domain)(!$cl_filter))");
                   }

		}else{
		
		  if($branch == "eleves")
		    {
		      if ($domain == "tous les domaines")
			{
			  $r = ldap_list($ds,$branch_eleve,"(&(cn=$letter*)(mail=*@*))");
			} else {
			  $mail = "*.a*"."@".$domain;
			  $r = ldap_list($ds,$branch_eleve,"(&(cn=$letter*)(mail=*@$domain))");
			}
		    }else{
		      
		      if($branch == "administrateur")
			{
		
			  if ($domain == "tous les domaines")
			    {
			      $r = ldap_list($ds,$branch_admin,"(&(cn=$letter*)(mail=*@*))");
			    } else {
			      $r = ldap_list($ds,$branch_admin,"(&(cn=$letter*)(mail=*@$domain))");
			    }
			  $is_admin=1;
			}
		    }
	    
		} // endif (getadminlevel)
		}


	      $cpt_nb_entries = 0;
	      $count_entries = ldap_count_entries($ds,$r);
	      if (ldap_count_entries($ds,$r)<=0)
		{
		  $buffer .=  "aucune entrée <br>";
		  
		} else {
		  
		  $ind = 0;
		  $e = ldap_first_entry($ds,$r);
		  do
		    {
		      $tab_result[$ind] = $e;
		      $ind++;
		      
		    } while (($e=ldap_next_entry($ds,$e)));

		  $buffer .= display_one($ds, $r, $branch, $domain, $tab_result, $letter, $ind, $is_admin  ) ;
		    }
	}


		   
    }

  
	  ldap_close($ds);
	  return $buffer ;
}	    


////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//                 fonctions reservés a l'affichage (de 20 en 20) d'une demande de listing des users
//
/////////////////////////////////////////////////////////////////////////////////////////////////////



//affiche les 20 premiers users
function display_one($ds, $r, $branch, $domain, $tab_result, $letter, $ind, $is_admin  )
{
global $PHP_AUTH_USER;

//$ind est le nombre de users listés o total
  
  $cpt_nb_entries = 0;
  $cpt = 0;
$buffer .= "<table border=1>";

   while (($cpt <= 20) && ($cpt_nb_entries < $ind)) 
   //while (($cpt <= 2000) && ($cpt_nb_entries < $ind)) // jojo
   {
      $cn =  ldap_get_values($ds,$tab_result[$cpt_nb_entries],"cn");
      $email = ldap_get_values($ds,$tab_result[$cpt_nb_entries],"mail");
      $uid = ldap_get_values($ds,$tab_result[$cpt_nb_entries],"uid");

$jojo_destroy=0;
if ($jojo_destroy){
$str="uid=$uid[0],ou=local,ou=eleves,ou=utilisateurs,ou=totototo,ou=ac-dijon,ou=education,o=gouv,c=fr";
print "supprime $str<br>";       // jojo DESTROY !
ldap_delete($ds,$str);
      $cpt++;
      $cpt_nb_entries++;
}else{      

if ($is_admin == 1)
	{
	  $typeadmin = ldap_get_values($ds,$tab_result[$cpt_nb_entries],"typeadmin");
	}
	  
      $buffer .= "<tr><td>$cn[0] &lt;$email[0]&gt;</td>";
      
      $buffer .="<td><a href=\"change-pwd-ldap.php?uid=$uid[0]&is_admin=$is_admin\">changer le mot de passe</a></td>";
      //if (get_admin_level($PHP_AUTH_USER) != 1)
      // ENCORE JOJO !
      if (1)
	{
	      
	  $buffer .= "<td><a href=\"edit-user-ldap.php?uid=$uid[0]&is_admin=$is_admin\">Editer</a></td>";
	} else {
	  $buffer .= "<td><a href=\"consult-password-user.php?uid=$uid[0]\">Consultation du mot de passe</a></td>"; 
	}
      //empecher l'effacement d'un "super" admin de classe
      if ( $typeadmin[0] != 1)
	{
	      
	  $buffer .= "<td><a href=\"remove-user-ldap.php?uid=$uid[0]&is_admin=$is_admin\">Effacer</td>";  
	}
      //empecher de changer de domaine de mail pour tous les administrateurs
      if ($is_admin != 1) 
	{
	      
	  $buffer .= "<td><a href=\"change-domain-mail.php?uid=$uid[0]&is_admin=$is_admin\">changer domaine mail</td>";
	}// jojo
	}
      $buffer .= "<tr>";
      $cpt++;
      $cpt_nb_entries++;
    } 
		       
  $buffer .= "</table>";

      //bouton suivant
 
  if ($cpt_nb_entries < $ind)
	{
	 
	   $buffer .= "<a href=\"resultat-list-ldap.php?branch=$branch&domain=$domain&booleen=1&letter=$letter&cpt_nb_entries=$cpt_nb_entries\">Suivant</a>" ;
	}

 return $buffer ;
}


// fonction de recherche officielle
// affiche de 20 en 20 les users demandées lors du listing
// les admin de classe se retrouvent aussi dans cette fonction pour pouvoir éditer
// leurs élèves (Joel)
function display_more($domain, $branch, $letter, $cpt_nb_entries)
{
   global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin ,$ldap_objclass_eleve, $PHP_AUTH_USER, $request_ldap;
    
   //Connection a au serveur  
   $ds=ldap_connect($ldap_server,$ldap_port);
   if (!$ds) {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      return ($buffer);
   }

   //Bind   
   $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
   if (!$r) {
      $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
      return ($buffer);
   }

   $is_admin=0;
   $buffer = '';
   
   // construction du filtre de recherche
   $filtre="(&(sn=$letter*)";
   
   // domaine 
   if ($domain != "tous les domaines") $filtre.="(mail=*@$domain)";

   if(get_admin_level($PHP_AUTH_USER) != 0) {
      // professeur ppal => recherche des élèves de la classe
      $cl_filter = "";
      foreach (get_admin_class($PHP_AUTH_USER) as $classe) {
         # construction du filtre sur les classes du prof
         $cl_filter.="(Divcod=$classe)";
      }
      $filtre.="(|$cl_filter)";
      $branche=$branch_eleve;
      $is_admin=0;
   }
   else {
      // administrateur => il a choisi sa branche de recherche
      if($branch == "administrateur") {
         $is_admin=1;
         $branche=$branch_admin;
      }
      else {
         $branche=$branch_eleve;
         $is_admin=0;
      }
   }
   // finalisation du filtre
   $filtre.= ")";
   
   // requête LDAP
   $r = ldap_list($ds,$branche,$filtre);
   $count_entries = ldap_count_entries($ds,$r);
   if (ldap_count_entries($ds,$r)<=0) {
      $buffer .=  "aucun utilisateur ne correspond à votre demande<br>";
      return ($buffer);
   }
   
   // tri par NOM de FAMILLE
   ldap_sort ($ds, $r, "sn");
   
   // parcours des entrées
   $ind = 0;
   $e = ldap_first_entry($ds,$r);
   do {
      $tab_result[$ind] = $e;
      $ind++;
   } while (($e=ldap_next_entry($ds,$e)));

   $buffer .= list_more($ds, $r, $branch, $domain, $tab_result, $ind, $cpt_nb_entries, $letter, $is_admin);
  
   ldap_close($ds);
   return $buffer;
}


//liste les 20 personnes suivantes ou precedentes demandees par l'utilisateur	    
function list_more($ds, $r, $branch, $domain, $tab_result, $ind, $cpt_nb_entries, $letter, $is_admin){
   
   // $cpt_nb_entries : à partir de quel indice commencer l'affichage des 20
   global $PHP_AUTH_USER;
   $cpt = 0;
   $buffer = "<table border=1>";
 
   while (($cpt <= 20) && ($cpt_nb_entries < $ind)) {
      $cn =  ldap_get_values($ds,$tab_result[$cpt_nb_entries],"cn");
      
      // ACK 28/10/2003 //
      // rapport d'erreur au minimum pour éviter l'éventuel Warning
      $old=error_reporting(1);
         $email = ldap_get_values($ds,$tab_result[$cpt_nb_entries],"mail");
	 if (! $email[0]) $email[0] = "email non initialisé";
      // rapport d'erreur à son niveau précédent
      error_reporting($old);
      // -------------- //
      $uid = ldap_get_values($ds,$tab_result[$cpt_nb_entries],"uid");

      // affichage : toto <toto@mail> | change pwd | editer | effacer
      $buffer .= "<tr><td>$cn[0] &lt;$email[0]&gt;</td>";
      $buffer .="<td><a href=\"change-pwd-ldap.php?uid=$uid[0]&is_admin=$is_admin\">
                 changer mot de passe</a></td>";
      $buffer .= "<td><a href=\"edit-user-ldap.php?uid=$uid[0]&is_admin=$is_admin\">Editer</a></td>";
      // seul l'administrateur peut effacer !
      if (strtolower($PHP_AUTH_USER) == 'administrateur') {
         $buffer .= "<td><a href=\"remove-user-ldap.php?uid=$uid[0]&is_admin=$is_admin\">Effacer</td>";
      }
      // changement du domaine mail exclusivement pour les élèves
      if ($is_admin != 1) {
	  $buffer .= "<td><a href=\"change-domain-mail.php?uid=$uid[0]&is_admin=$is_admin\">
	              changer domaine mail</td>";
      }
      $buffer .= "</tr>";
      $cpt++;
      $cpt_nb_entries++;
  } 
		       
  $buffer .= "</table>";

// (urlencode pour compatibilité Netscape)
$domain=urlencode($domain);
  //bouton suivant 
  if ($cpt_nb_entries < $ind) {
     $buffer .= "<a href=\"resultat-list-ldap.php?branch=$branch&domain=$domain&booleen=1&letter=$letter&cpt_nb_entries=$cpt_nb_entries\">Suivant</a><br>" ;
   }
   //bouton precedent
   if (($cpt_nb_entries-$cpt-21) >= 0) { 
      $cpt_nb_entries = $cpt_nb_entries-$cpt-21;
      $buffer .= "<br><a href=\"resultat-list-ldap.php?branch=$branch&domain=$domain&booleen=1&letter=$letter&cpt_nb_entries=$cpt_nb_entries\">Precedent</a>" ;
   }

   return $buffer ;
}


// renvoit le mail d'un utilisateur
function get_mail($user)
{
  global $typeadmin, $is_admin, $ds, $r, $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve, $branch_admin, $branch_groupe, $ldap_objclass_eleve, $PHP_AUTH_USER, $domaine_internet;
    
   //Conection a au serveur  
   $ds=ldap_connect($ldap_server,$ldap_port);
   if (!$ds)
   {
      print "Can't connect to Ldap server ($ds)\n";
      exit();
   
   } else {
      
      //Bind   
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
      {
         print "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	 exit();
	 
      } else {
         $r = ldap_list($ds,$branch_admin,"cn=$user");

	 if (ldap_count_entries($ds,$r) == 1)
	 {
	    $e = ldap_first_entry($ds,$r);
	    $tab=ldap_get_values($ds,$e,"mail");
	    $mail=$tab[0];
	 }
	 else {
	    $mail=$email_admin;
	 }
      }
   }
   ldap_close($ds);
   return $mail ;
}	    

