<?php
/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 
 Modifications le 03/10/2003 pour compatibilité Scribe 1.0
 <joel.cuissinat@ac-dijon.fr>
 
 */

function mail_list_users() {

   global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $email_admin;

   $ds=connexion_ldap();
   // recherche des utilisateurs
   $r = ldap_search($ds,"$ldap_base","(objectclass=posixAccount)");
   
   if (ldap_count_entries($ds,$r)<=0)  {
      ldap_close($ds);
      print "Aucun utilisateur n'a été trouvé";
      return;
   }

   $rapport = "Nombre d'utilisateurs : " . ldap_count_entries($ds,$r) . "\n";
   
   // rapport d'erreur min pour éviter les warning
   $old=error_reporting(1);
   
   $e = ldap_first_entry($ds,$r);
   do {
      $email = ldap_get_values($ds,$e,"mail");
      $uid = ldap_get_values($ds,$e,"uid");
      //$pass = ldap_get_values($ds,$e,"userPassword");
      $rapport .= "$uid[0] *** $email[0] ***\n";
      //for ($i = 0 ; $i < count($email)-1 ; $i++) { $rapport .= "  <$email[$i]>\n"; }$rapport .= "\n";
   } while (($e=ldap_next_entry($ds,$e)));

   $rapport .="\n";

   //print "mail($email_admin,Listes des groupes du domaine $ldap_base,$rapport)";
   if (!mail($email_admin,"Listes des boites aux lettres du domaine $ldap_base",$rapport)) {
      print "Erreur fonction mail";
   }
   ldap_close($ds);

   // ancien rapport d'erreur
   error_reporting($old);
}


function mail_list_groups() {
   global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $email_admin;

   $ds=connexion_ldap();

   $r = ldap_search($ds,"$ldap_base","objectclass=posixGroup");
   if (ldap_count_entries($ds,$r)<=0){
     ldap_close($ds);
     print "Aucun groupe trouvé";
     return;
   }

   $rapport = "Nombre de groupes : " . ldap_count_entries($ds,$r) . "\n\n";
  
   // rapport d'erreur au minimum pour éviter l'éventuel Warning
   $old=error_reporting(1);
   
   $e = ldap_first_entry($ds,$r);
   do {
	  $uid = ldap_get_values($ds,$e,"cn");
	  //$dn = ldap_get_dn($ds,$e);
	  //$domains = ldap_explode_dn($dn,1);
	  //$domain_name = $domains[1];
	  $membres= ldap_get_values($ds,$e,"memberUid");	  
	  $description = ldap_get_values($ds,$e,"description");
	  $rapport.="Groupe $uid[0] ($description[0])\n Membres : ";
	  //$rapport .= "<$uid[0]@$domain_name>  $description[0]\n";
	  for ($i = 0 ; $i < count($membres)-1 ; $i++) {
		  $rapport .= "$membres[$i] ";
	  }
	  $rapport .= "\n\n";
  
   } while (($e=ldap_next_entry($ds,$e)));
   // rapport d'erreur à son niveau précédent
   error_reporting($old);

   $rapport .="\n";

   //print "mail($email_admin,Listes des groupes du domaine $ldap_base,$rapport)";
   if (!mail($email_admin,"Listes des groupes du domaine $ldap_base",$rapport)) {
      print "Erreur fonction mail";
   }

   ldap_close($ds);
}
?>
