<?php

/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */


function delete_user_ask($uid,$is_admin)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve,$ldap_objclass_eleve,$branch_admin,$ldap_objclass_admin;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      // exit();
    } else {
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {
  
	  if ($is_admin == 1) {
	    $r = ldap_read($ds,"uid=$uid,$branch_admin","objectclass=$ldap_objclass_admin");
	  }else{
	    $r = ldap_read($ds,"uid=$uid,$branch_eleve","objectclass=$ldap_objclass_eleve");
	  }

	  if (@ldap_count_entries($ds,$r)<=0)
	    {
	      $buffer = "L'utilisateur n'existe pas\n";
	      // exit();
	    } else {

	      //$buffer = "<html><head><title>Effacer un utilisateur</title></head><body>");
	      $buffer = "Etes vous vraiment sur de vouloir effacer cet utilisateur: $uid";
	      $buffer .= "<form>";
	      $buffer .= "<input type=hidden name=uid value=\"$uid\">";
	      $buffer .= "<input type=hidden name=confirm value=\"$uid\">";
	      $buffer .= "<input type=hidden name=is_admin value=\"$is_admin\">";
	      $buffer .= "<input type=submit name=action value=\"Effacer\">";
	      $buffer .= "<input type=submit name=action value=\"Non\">";
	      $buffer .= "</form>";
	    }
	}
    }

	      ldap_close($ds);
	      return $buffer;
}


function delete_user_noask($uid,$is_admin)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass,$branch_eleve,$ldap_objclass_eleve,$branch_admin,$ldap_objclass_admin,$perl_path;

  // visiblement smbldap-userdel -r username marche bien...
  // -r => destruction du home dir
  // enlève l'utilisateur des groupes
  if ( $uid == 'admin'){
     $ret= `sudo /usr/sbin/smbldap-userdel $uid` ;
  }
  else {
     $ret= `sudo /usr/sbin/smbldap-userdel -r $uid` ;
  }
  if (! $ret) {
     $buffer="L'utilisateur '$uid' a été retiré<br>";
     $buffer .= "<form action=list-user-ldap.php>";
     $buffer .= "<center><input type=\"submit\" value=\"Retour\">";
     $buffer .= "</form>";
  }
  else{
     $buffer="Un problème est survenu lors de la suppression de l'utilisateur $uid ($ret)";
     $buffer .= "<form action=list-user-ldap.php>";
     $buffer .= "<center><input type=\"submit\" value=\"Retour\">";
     $buffer .= "</form>";
  }
   
  return $buffer;
}

?>
