<?php

/*
 * Airelle - Ldap administration for mail server
 * Copyright (c) 2000 Alcôve, Luc Saillard <luc.saillard@fr.alcove.com>
 *			      Igor Genibel <Igor.Genibel@fr.alcove.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */



function list_attribute()
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass_eleve, $PHP_AUTH_USER;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      // exit();
    } else {
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {

	  $r = ldap_search($ds,"$ldap_base","(objectclass=$ldap_objclass_eleve)");
	  if (ldap_count_entries($ds,$r)<=0)
	    {
	      $buffer = "Aucun utilisateur ne correspond aux critères proposés\n";
	      // exit();
	    } else {

	      $entry = ldap_first_entry($ds, $r);

	      $attrs = ldap_get_attributes($ds, $entry);

	      for ($i=0; $i<$attrs["count"]; $i++)
		{
		  $buffer .=  "<option> $attrs[$i]\n</option>"; 
		}
	    }
	}
    }
  ldap_close($ds);
  return $buffer ;
}

function list_attribute_admin()
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass_admin, $PHP_AUTH_USER;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
      $buffer = "Can't connect to Ldap server ($ds)\n";
      // exit();
    } else {
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {

	  $r = ldap_search($ds,"$ldap_base","(objectclass=$ldap_objclass_admin)");
	  if (ldap_count_entries($ds,$r)<=0)
	    {
	      $buffer = "Aucun utilisateur ne correspond aux critères proposés\n";
	      // exit();
	    } else {

	      $entry = ldap_first_entry($ds, $r);

	      $attrs = ldap_get_attributes($ds, $entry);

	      for ($i=0; $i<$attrs["count"]; $i++)
		{
		  $buffer .=  "<option> $attrs[$i]\n</option>"; 
		}
	    }
	}
    }
  ldap_close($ds);
  return $buffer ;
}

function view_result($domain,$query,$is_admin)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass, $ldap_grpclass, $PHP_AUTH_USER, $branch_eleve, $branch_admin;
  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
     $buffer = "Can't connect to Ldap server ($ds)\n";
     // exit();
    } else {
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {
  
	  if ($is_admin == 0 )
	    {	
	      if (get_admin_level($PHP_AUTH_USER) != 1)
		{
		  if ($domain == "tous les domaines")
		    {
		      $r = ldap_search($ds,"$branch_eleve","(&(mail=*@*)(sn=*$query*))");
		    } else {
		      
		      $r = ldap_search($ds,"$branch_eleve","(&(mail=*@$domain)(sn=*$query*))");
		    }
		}else{
		  $cl_filter="";
		  foreach (get_admin_class($PHP_AUTH_USER) as $classe) {
		     # construction du filtre sur les classes du prof
		     $cl_filter.="(Divcod=$classe)";
		  }
		  if ($domain == "tous les domaines")
		    {
		      
		      $r = ldap_search($ds,"$branch_eleve","(&(mail=*@*)(sn=*$query*)(|$cl_filter))");
		    } else {
		      
		      $r = ldap_search($ds,"$branch_eleve","(&(mail=*@$domain)(sn=*$query*)(|$cl_filter))");
		    }
		}
	    }else{
	      if ( $domain == "tous les domaines")
		{
		  
		  $r = ldap_search($ds,"$branch_admin","(&(mail=*@*)(sn=*$query*))");
		} else {
		  
		  $r = ldap_search($ds,"$branch_admin","(&(mail=*@$domain)(sn=*$query*))");
		}
	    }
	  if (($count=ldap_count_entries($ds,$r))<=0)
	    {
	      $buffer = "Aucun utilisateur ne correspond aux critères proposés\n";
	      // exit();
	    } else {

	      $buffer = "Il y a $count résultat(s) pour votre recherche\n";

	      $buffer .= "<table border=1>";
	      
	      // tri par NOM de FAMILLE
	      ldap_sort ($ds, $r, "sn");
	      
	      $e = ldap_first_entry($ds,$r);
	      do
		{
		  $email = ldap_get_values($ds,$e,"mail");
		  $o = ldap_get_values($ds,$e,"objectclass");
# Affichage pour une personne
		  //$cn = ldap_get_values($ds,$e,"cn");
		  $cn=ldap_get_values($ds,$e,"displayName");
		  $uid = ldap_get_values($ds,$e,"uid");
		  $domain_name=substr(strchr($email[0],"@"),1);
		  if(get_admin_level($PHP_AUTH_USER) == 1) {
		    $buffer .= "<tr><td colspan=2>$cn[0] &lt;$email[0]&gt;</td>";

//		    $buffer .= "<td><a href=\"consult-password-user.php?uid=$uid[0]\">consulter le mot de passe</a></td>";

		    $buffer .= "<td><a href=\"change-pwd-ldap.php?uid=$uid[0]&is_admin=0\">changer mot de passe</a></td>";
		    $buffer .= "<td><a href=\"edit-user-ldap.php?uid=$uid[0]&is_admin=0\">Editer</a></td>";
		    $buffer .= "<td><a href=\"remove-user-ldap.php?uid=$uid[0]&is_admin=0\">Effacer</td>";
		    $buffer .= "<td><a href=\"change-domain-mail.php?uid=$uid[0]&is_admin=0\">changer domaine mail</td>";
		    // un admin de classe ne modifie que des élèves : is_admin=0 !
		    $buffer .="</tr>";
		   
		  }else{
//ADMINTOP		  
		    $buffer .= "<td colspan=2>$cn[0] &lt;$email[0]&gt;</td>";
		    $buffer .= "<td><a href=\"change-pwd-ldap.php?uid=$uid[0]&is_admin=0\">Changer mot de passe</a></td>";
		    $buffer .= "<td><a href=\"edit-user-ldap.php?uid=$uid[0]&is_admin=0\">Editer</a></td>";
		    $buffer .= "<td><a href=\"remove-user-ldap.php?uid=$uid[0]&is_admin=0\">Effacer</td>";
		    $buffer .= "<td><a href=\"change-domain-mail.php?uid=$uid[0]&is_admin=0\">Changer domaine mail</td></tr>";
		  }
		} while (($e=ldap_next_entry($ds,$e)));
	      $buffer .= "</table>";
	    }
	}
    }

	      ldap_close($ds);
	      return $buffer ;
}



function view_result_admin($domain,$query,$is_admin)
{
  global $ldap_server, $ldap_port, $ldap_bindpw, $ldap_binddn, $ldap_base, $ldap_objclass, $ldap_grpclass, $PHP_AUTH_USER, $branch_eleve, $branch_admin;

  $ds=ldap_connect($ldap_server,$ldap_port);
  if (!$ds)
    {
     $buffer = "Can't connect to Ldap server ($ds)\n";
     // exit();
    } else {
      $r=ldap_bind($ds,$ldap_binddn,$ldap_bindpw);
      if (!$r)
	{
	  $buffer = "Can't bind to Ldap server (Perhaps a bad password ?)\n";
	  // exit();
	} else {
  
	  if ($is_admin == 0 )
	    {	
	      if (get_admin_level($PHP_AUTH_USER) != 1)
		{
		  if ( $domain == "tous les domaines")
		    {
		      $r = ldap_search($ds,"$branch_eleve","(&(sn=*$query*))");
		    } else {
		      $r = ldap_search($ds,"$branch_eleve","(&(mail=*@$domain)(sn=*$query*))");
		    }
		}else{
		  $classe = get_admin_class($PHP_AUTH_USER);
		  if ( $domain == "tous les domaines")
		    {
		      $r = ldap_search($ds,"$branch_eleve","(&(mail=*@*)(sn=*$query*)(Divcod=$classe))");
		    } else {
		      $r = ldap_search($ds,"$branch_eleve","(&(mail=*@$domain)(sn=*$query*)(Divcod=$classe))");
		    }
		}
	    }else{
	      if ( $domain == "tous les domaines")
		{
		  $r = ldap_search($ds,"$branch_admin","(&(sn=*$query*))");
		} else {
		  $r = ldap_search($ds,"$branch_admin","(&(mail=*@$domain)(sn=*$query*))");
		}
	    }
	  if (($count=ldap_count_entries($ds,$r))<=0)
	    {
	      $buffer = "Aucun utilisateur ne correspond aux critères proposés\n";
	      // exit();
	    } else {

	      $buffer = "Il y a $count résultat(s) pour votre recherche\n";

	      $buffer .= "<table border=1>";

	      // tri par NOM de FAMILLE
              ldap_sort ($ds, $r, "sn");
	      
	      $e = ldap_first_entry($ds,$r);
	      do
		{
		  // rapport d'erreur au minimum pour éviter l'éventuel Warning
		  $old=error_reporting(1);
		  $email = ldap_get_values($ds,$e,"mail");
		  if (! $email[0]) $email[0] = "email non initialisé";
		  // rapport d'erreur à son niveau précédent
		  error_reporting($old);
		  // -------------- //
		  $o = ldap_get_values($ds,$e,"objectclass");
# Affichage pour une personne
		  //$cn = ldap_get_values($ds,$e,"cn");
		  $cn = ldap_get_values($ds,$e,"displayName");
		  $uid = ldap_get_values($ds,$e,"uid");
		  $domain_name=substr(strchr($email[0],"@"),1);

		  if ($is_admin == 1)
		    {
		      $typeadmin = ldap_get_values($ds,$e,"typeadmin");
		    }

		  if(get_admin_level($PHP_AUTH_USER) == 1) {
//ADMIN DE CLASSE
		    $buffer .= "<tr><td colspan=2>$cn[0] &lt;$email[0]&gt;</td><td><a href=\"edit-user-ldap.php?uid=$uid[0]&is_admin=1\">Editer</a></td>";
		    $buffer .= "<td><a href=\"change-pwd-ldap.php?uid=$uid[0]&is_admin=1\">changer le mot de passe</a></td>";
		    if ( $typeadmin[0] != 1)
		      {
			$buffer .= "<td><a href=\"remove-user-ldap.php?uid=$uid[0]&is_admin=1\">Effacer</td>";       
		      }
		    $buffer .= "</tr>";
		     $buffer .= "<td><a href=\"change-domain-mail.php?uid=$uid[0]&is_admin=1\">changer le domaine mail</td></tr>";
		  }else{
//ADMINTOP		  
		    $buffer .= "<tr><td colspan=2>$cn[0] &lt;$email[0]&gt;</td>";
		    $buffer .= "<td><a href=\"change-pwd-ldap.php?uid=$uid[0]&is_admin=1\">changer mot de passe</a></td>";
		    $buffer .= "<td><a href=\"edit-user-ldap.php?uid=$uid[0]&is_admin=1\">Editer</a></td>";
		     $buffer .= "<td><a href=\"remove-user-ldap.php?uid=$uid[0]&is_admin=1\">Effacer</td>";
//		     $buffer .= "<td><a href=\"change-domain-mail.php?uid=$uid[0]&is_admin=1\">changer le domaine mail</td></tr>";
/*		    if ( $typeadmin[0] != 1)
		      {
		      }*/
		    $buffer .= "</tr>";
		  }
		} while (($e=ldap_next_entry($ds,$e)));
	      $buffer .= "</table>";
	    }
	}
    }

	      ldap_close($ds);
	      return $buffer ;
}






?>
